// cfpfactory.h
// This file described the Configpp Factory class, the class which manages and creates
//  all other Configpp-buildable classes.



#ifndef INC_cfpfactoryh
#define INC_cfpfactoryh

#include "cfpinc.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Configpp{



// We have a single global factory which will handle all automatic registration of
//  library classes.  It is nescesary to make this a global since the callers
//  will need to refer to it *prior* to any communication from the system (ie via
//  their own global instantiation).









//--------------------------------------------------------------------------------
//---- CfpFactory ----------------------------------------------------------------
//--------------------------------------------------------------------------------

// The CfpFactory container which holds and constructs Configpp buildable classes
// Implemented as a map (where the key is the name, and the val is the CfpObject).

class CfpFactory
{
public:
  static int dummyv;
  bool newspawners;
private:
  Configpp *configppp;								// pointer to parent parser
  map<string, CfpClass *> classmanager;						// map version of class container
  deque<CfpObject *> spawnermanager;					        // holds spawners
  deque<CfpObject *> pending;   					        // holds pending spawners
  map<string, CfpUnit *> unitmanager;						// map version of unit container
  map<string, CfpType *> typemanager;						// map version of type container
  CfpClass *spawnerclassp;
public:
  CfpFactory();						                        // constructor
  ~CfpFactory();								// destructor
public:
  CfpFactory *getaddress() {return this;};                                 // return pointer to us.
  CfpClass *registerclass(string pname,string cname,CfpObject *spawnerp);	// register new library class
  CfpClass *lookupClass(string classname, bool throwerr=true);			// lookup a library class
  CfpUnit *registerunit(CfpUnit *newunitp);						// register new unit object
  CfpUnit *lookupUnit(string unitname, bool throwerr=true);			// lookup a unit entry
  CfpType *registertype(CfpType *newtypep);						// register new unit object
  CfpType *lookupType(string typname, bool throwerr=true);			// lookup a unit entry
  string namehint(string name);							// return a hint about name
  void preinterpret();								// tell each class we are begining
  void postinterpret();								// tell each class we are done
  CfpClass *getspawnerclassp(){return spawnerclassp;};				// accessor;
  Configpp *getcfpp(){return configppp;};						// accessor;
  void addalias(string aliasstr,string keyword,bool casesensitive=true);	// add a new alias to the list of aliases
public:
  void registerspawner(CfpObject *spawnerp,string packagename);
  void setconfigppp(Configpp *inconfigppp);
  void viewcommandline(int &argc,char **argv);
  void updatespawners();
};






//}
// Namespace close-brace
#endif
