// cfplibs.C

// Ideally, we would like each library to be able to self register with the system
//  but currently the C compiler refuses to instantiate the global variables in the
//  external libraries, so we require a file in this main library which instantiates one of each object.
// This could probably be done more elegantly with some clever stuff in the Makefile,
//  but since we really want to eventually implement it as a dynamic linking scheme,
//  we aren't going to stress over it now.



// Unfortunately we require these includes for the compiler

#include "cfplibs/fltk/swfltk.h"
#include "cfplibs/biobot/swbiobot.h"
#include "cfplibs/datafactory/swdatafactory.h"
#include "cfplibs/plot/swplot.h"
#include "cfplibs/movie/swmovie.h"
#include "cfplibs/hexcontrol/swhexcontrol.h"
#include "cfplibs/pdcontrol/swpdcontrol.h"
#include "cfplibs/macros/swmacros.h"


CfpstdInclude dummy_CfpstdInclude;

CfpstdInline dummy_CfpstdInline;

CfpstdWire dummy_CfpstdWire;

CfpstdSplice dummy_CfpstdSplice;

CfpstdDatastream dummy_CfpstdDatastream;

CfpSpliceNoise dummy_CfpSpliceNoise;

CfpSpliceDelay dummy_CfpSpliceDelay;

SWfltk_modal dummy_SWfltk_modal;

SWfltk_widget dummy_SWfltk_widget;

SWbiobot_obj dummy_SWbiobot_obj;

SWdatafactory_obj dummy_SWdatafactory_obj;

SWplot_obj dummy_SWplot_obj;

SWmovie_obj dummy_SWmovie_obj;

SWhexcontrol_obj dummy_SWhexcontrol_obj;

SWpdcontrol_obj dummy_SWpdcontrol_obj;

SWmacro_obj dummy_SWmacro_obj;

