//  Jesse Reichler, January 1996
//  Fred Delcomyn
//
//  base.C
//  This file contains the class methods for the Base class,
//   which is the central body of a robot, to which all chains connect.
//  See header file (.h) for description
//  
//

#include "misc.def"
#include "physobject.h"
#include "base.h"
#include "robot.h"






Base:: Base(const char *basename, World *worldp, int inbasetype)
  : Physicalobject(basename, worldp, NO)
{
  // initialize the base
  basetype=inbasetype;
  
  // Call computevals to calculate base inertia matrix Ib   (see dynamics.C)
  Allocatevals();
  Computevals();
}








void Base::movie_load(FILE *moviefp)
{
  // load all data for a base
  Physicalobject::movie_load(moviefp);

  // 5/8/97 one way
  DbAe=~(orientationval());
  // another
  //  Jmatload(DbAe,moviefp,3,3);
}


void Base::movie_save(FILE *moviefp)
{
  // save all data for a link
  Physicalobject::movie_save(moviefp);
  
  // 5/8/97 alternate way
  //  Jmatsave(DbAe,moviefp,3,3);
}


