//  Jesse Reichler, January 1996
//  Fred Delcomyn
//
//  base.h
//  This file contains the class definition for the Base class,
//   which is the central body of a robot, to which all chains connect.
//  The Chain class is defined in a separate file.
//  
//
#ifndef Base_defined
#define Base_defined

#include "misc.def"
#include "physobject.h"



// Base just contains the geometry,mass, etc.. of the robot base
class Base : public Physicalobject
{
  friend class Chain;
  friend class Robot;
  friend class Rot;
private:
  int basetype;
private:
  perMatrix DI;
  perMatrix DISTAR;
  perMatrix DBSTAR;
  perMatrix DB;
  perVector Da;
  perVector Db;
  perVector DaG;
  perVector Dv;
  perVector DEulers;
  perMatrix DeAb;
  perMatrix DbAe;
private:
  perVector tSUMb;
  perMatrix tSUMi;
public:
  Base(const char *basename,class World *worldp, int inbasetype);
public:
  virtual void update(double deltat);
private:
  void Allocatevals();
  void Computevals();
  void ComputeDeAb();
  void iterate(percision deltat);
public:
  virtual void movie_load(FILE *moviefp);
  virtual void movie_save(FILE *moviefp);
};





#endif


