//  Jesse Reichler, February 1996
//  Fred Delcomyn
//
//  jessdh.C
//  annoying Dennavit hartenberg matrix builder
//   want to use Welton's but it's 4x4, maybe in next phase



#include "misc.def"
#include "matrixinc.h"
#include "jessdh.h"

#include <math.h>



perMatrix JessmakeDH(percision alpha_twist, percision a_length, percision d_offset, percision theta_angle)
{
  perMatrix mat(3,3);
  
  // fill the R3 matrix passed (it has already been created)
  // with DH transform (see Craig 1986)
  percision stheta=sin(theta_angle);
  percision ctheta=cos(theta_angle);
  percision salpha=sin(alpha_twist);
  percision calpha=cos(alpha_twist);
  
  //Original from legsim
  // See Spong 66, NOT Craig
  mat(0,0)=ctheta;
  mat(1,0)=stheta;
  mat(2,0)=0.0;
  mat(0,1)=-calpha*stheta;
  mat(1,1)=calpha*ctheta;
  mat(2,1)=salpha;
  mat(0,2)=salpha*stheta;
  mat(1,2)=-salpha*ctheta;
  mat(2,2)=calpha;
  
  return mat;
}



perVectorR3 JessmakeDHp(percision alpha_twist, percision a_length, percision d_offset, percision theta_angle)
{
  perVectorR3 vec;
  
  // fill the R3 vector passed (it has already been created)
  // with DH point transform (see Craig 1986)
  
  vec(0)=a_length;
  vec(1)=d_offset*sin(alpha_twist);
  vec(2)=d_offset*cos(alpha_twist);
  
  return vec;
}


perMatrix JessmakeDH4(percision alpha_twist, percision a_length, percision d_offset, percision theta_angle)
{
  perMatrix mat(4,4);
  
  // fill the R4 matrix passed (it has already been created)
  // with DH transform (see Spong p.66 NOT Craig)
  percision stheta=sin(theta_angle);
  percision ctheta=cos(theta_angle);
  percision salpha=sin(alpha_twist);
  percision calpha=cos(alpha_twist);
  
  mat.fill(0.0);
  
  mat(0,0)=ctheta;
  mat(1,0)=stheta;
  mat(2,0)=0.0;
  mat(0,1)=-stheta*calpha;
  mat(1,1)=calpha*ctheta;
  mat(2,1)=salpha;
  mat(0,2)=salpha*stheta;
  mat(1,2)=-ctheta*salpha;
  mat(2,2)=calpha;
  
  mat(0,3)=a_length*ctheta;
  mat(1,3)=a_length*stheta;
  mat(2,3)=d_offset;
  mat(3,3)=1.0;
  mat(3,0)=0.0; mat(3,1)=0.0; mat(3,2)=0.0;
  
  return mat;
}


perMatrix JessDH4identity()
{
  // create the 4x4 identity matrix
  perMatrix mat(4,4);
  
  mat.fill(0.0);
  mat(0,0)=1.0;
  mat(1,1)=1.0;
  mat(2,2)=1.0;
  mat(3,3)=1.0;
  return mat;
}

