//  Jesse Reichler, January 1996
//  Fred Delcomyn
//
//  misc.C
//  This file contains miscelaneous functions not don't really belong
//   in one place.
//
//
#include "misc.def"
#include "misc.h"
#include "matrixinc.h"

#include <math.h>
#include <stdlib.h>
#include <string.h>








perMatrix JessCompose66(perMatrix m00,perMatrix m01, perMatrix m10, perMatrix m11)
{
  perMatrix transmat(6,6);
  int i,j;
  // Compose a 6x6 matrix from 4 3x3 matrices,
  for (i=0;i<=2;++i)
    {
      for (j=0;j<=2;++j)
	{
	  transmat(i+0,j+0)=m00(i,j);
	  transmat(i+0,j+3)=m01(i,j);
	  transmat(i+3,j+0)=m10(i,j);
	  transmat(i+3,j+3)=m11(i,j);
	}
    }
  
  return transmat;
}



perVector JessCompose61(perVector v0,perVector v1)
{
  // Compose a 6x1 vector from 2 3x1 vectors
  perVector retvec(6,ColV);

  retvec(0)=v0(0);
  retvec(1)=v0(1);
  retvec(2)=v0(2);
  retvec(3)=v1(0);
  retvec(4)=v1(1);
  retvec(5)=v1(2);

  return retvec;
}




perMatrix JessTilde(perVectorR3 a)
{
  // perform the tilde operation on a 3 vector, as described in
  // Freeman thesis (1989, p.27)
  perMatrix retmat(3,3);

  retmat.fill(0.0);
  retmat(0,0)=0.0;
  retmat(0,1)=-1.0*a(2);
  retmat(0,2)=a(1);
  retmat(1,0)=a(2);
  retmat(1,1)=0.0;
  retmat(1,2)=-1.0*a(0);
  retmat(2,0)=-1.0*a(1);
  retmat(2,1)=a(0);
  retmat(2,2)=0.0;

  return retmat;
}



perVector JessUntilde(perMatrix mat)
{
  // reconstruct the 3 vector from the 3x3 tildeizied matrix
  perVector transvec(3,ColV);

  transvec(0)=mat(2,1);
  transvec(1)=mat(0,2);
  transvec(2)=mat(1,0);

  return transvec;
}


perMatrix JessE33()
{
  // Return a 3x3 identity matrix
  perMatrix retmat(3,3);
  
  retmat.fill(0.0);
  retmat(0,0)=1.0;
  retmat(1,1)=1.0;
  retmat(2,2)=1.0;
  return retmat;
}



perMatrix Jessup33(perMatrix mat66)
{
  // Return the upper 3x3 submatrix of a 6x6
  // I do this manually because Welton's submatrix routines don't work reliably
  perMatrix retup(3,3);

  retup(0,0)=mat66(0,0);
  retup(0,1)=mat66(0,1);
  retup(0,2)=mat66(0,2);
  retup(1,0)=mat66(1,0);
  retup(1,1)=mat66(1,1);
  retup(1,2)=mat66(1,2);
  retup(2,0)=mat66(2,0);
  retup(2,1)=mat66(2,1);
  retup(2,2)=mat66(2,2);

  return retup;
}



perMatrix Jesslwr33(perMatrix mat66)
{
  // Return the lower left 3x3 submatrix of a 6x6
  // I do this manually because Welton's submatrix routines don't work reliably
  perMatrix retlwr(3,3);

  retlwr(0,0)=mat66(3,0);
  retlwr(0,1)=mat66(3,1);
  retlwr(0,2)=mat66(3,2);
  retlwr(1,0)=mat66(4,0);
  retlwr(1,1)=mat66(4,1);
  retlwr(1,2)=mat66(4,2);
  retlwr(2,0)=mat66(5,0);
  retlwr(2,1)=mat66(5,1);
  retlwr(2,2)=mat66(5,2);

  return retlwr;
}



perVector Jess3rdrow(perMatrix mat66)
{
  // Return the 3rd row of the matrix
  // I do this manually because Welton's submatrix routines don't work reliably
  perVector retrow(6);

  retrow(0)=mat66(2,0);
  retrow(1)=mat66(2,1);
  retrow(2)=mat66(2,2);
  retrow(3)=mat66(2,3);
  retrow(4)=mat66(2,4);
  retrow(5)=mat66(2,5);

  return retrow;
}



perVector Jess3rdcol(perMatrix mat66)
{
  // Return the 3rd col of the matrix
  // I do this manually because Welton's submatrix routines don't work reliably
  perVector retcol(6);

  retcol(0)=mat66(0,2);
  retcol(1)=mat66(1,2);
  retcol(2)=mat66(2,2);
  retcol(3)=mat66(3,2);
  retcol(4)=mat66(4,2);
  retcol(5)=mat66(5,2);

  return retcol;
}


perVector JessCholesky(perMatrix h,perVector b)
{
  // Solve for qdd using cholesky from Freeman Thesis (1989, p.149)
  perVector qdd(6,ColV);
  perVector qdd2(6,ColV);
  int i,j,k;
  percision temp,xk;
  perMatrix origh(6,6);

  // reliable old method
  qdd=Solve(h,b);

  return qdd;
  
  origh=h;
  
  // perform cholesky decomp
  for (k=0;k<6;k++)
    {
      for (i=0;i<k;i++)
	{
	  temp=0.0;
	  for (j=0;j<i;j++)
	    temp+=h(i,j)*h(k,j);
	  h(k,i)=(h(k,i)-temp)/h(i,i);
	}
      temp=0;
      for (j=0;j<k;j++)
	temp+=pow(h(k,j),2);
      h(k,k)=sqrt(h(k,k)-temp);
    }
  
  // start solving the resulting L LT system
  for (k=0;k<6;k++)
    qdd(k)=b(k);
  for (k=0;k<6;k++)
    {
      xk=qdd(k)/h(k,k);
      for (i=k+1;i<6;++i)
	qdd(i)=qdd(i)-h(i,k)*xk;
      qdd(k)=xk;
    }

  for (k=5;k>=0;k--)
    {
      xk=qdd(k)/h(k,k);
      for (i=k-1;i>=0;i--)
	qdd(i)=qdd(i)-h(k,i)*xk;
      qdd(k)=xk;
    }

  qdd2=Solve(origh,b);
  qdd=qdd2;
  
  return qdd;
}




perMatrix JessmakeA(percision a_length, percision d_offset, percision alpha_twist, percision theta_angle)
{
   perMatrix mat(3,3);

   // fill the R3 matrix passed (it has already been created)
   // with modified DH transform (see Freeman 1989, p.54)
   // this is A[i-1][i].
   percision stheta=sin(theta_angle);
   percision ctheta=cos(theta_angle);
   percision salpha=sin(alpha_twist);
   percision calpha=cos(alpha_twist);


   mat(0,0)=ctheta;
   mat(0,1)=-stheta;
   mat(0,2)=0.0;
   mat(1,0)=calpha*stheta;
   mat(1,1)=calpha*ctheta;
   mat(1,2)=-salpha;
   mat(2,0)=salpha*stheta;
   mat(2,1)=salpha*ctheta;
   mat(2,2)=calpha;

   // This IS nesc. to secure the right A matrix to [i] from [i-1], given
   //  parameters from link i
   mat=~mat;

   return mat;
 }


perVector Jessmakeci(percision a_length, percision d_offset, percision alpha_twist, percision theta_angle)
{
   // construct ci (Freeman Thesis 1989, p.54)
   perVector cvec(3,ColV);
   percision salpha=sin(alpha_twist);
   percision calpha=cos(alpha_twist);

   cvec(0)=a_length;
   cvec(1)=-1.0*d_offset*salpha;
   cvec(2)=d_offset*calpha;

   return cvec;
}



perMatrix JessmakeX(perMatrix A, perVector c)
{
  // construct  X[i][i-1] (Freeman Thesis 1989, p.27);
  // A is A[i][i-1], c is c[i]
  perMatrix mat3a(3,3);
  perMatrix mat3b(3,3);
  perMatrix mat3c(3,3);
  perMatrix retmat(6,6);
  perMatrix Z3(3,3);

  // make Z3
  Z3.fill(0.0);
  
  // see [Featherstone 1989 p.26] or [Freeman Thesis p. 27]
  mat3a=JessTilde(c);
  mat3b=~mat3a;
  mat3c=A*mat3b;
  
  retmat=JessCompose66(A,Z3,mat3c,A);
  return retmat;
}



perMatrix JessmakeXi(perMatrix A, perVector c)
{
  // construct  X[i-1][i] (Freeman Thesis 1989, p.27); A is A[i][i-1], c is c[i]
  perMatrix mat3a(3,3);
  perMatrix mat3b(3,3);
  perMatrix mat3c(3,3);
  perMatrix retmat(6,6);
  perMatrix retmat2(6,6);
  perMatrix retmat3(6,6);
  perMatrix Z3(3,3);
  perMatrix Ai;
  
  // make Z3
  Z3.fill(0.0);

  // see [Featherstone 1989 p.26]
  A=~A;
  mat3a=JessTilde(c);
  mat3c=mat3a*A;
  retmat=JessCompose66(A,mat3c,Z3,A);

  return retmat;
}


perMatrix JessmakeT(perMatrix A, perVector c)
{
  // construct  T[i][i-1] (Freeman Thesis 1989, p.27);
  // A is A[i-1][i], c is c[i]
  int i,j;
  perMatrix T(4,4);

  T.fill(0.0); //nesc. to clear matrix first
  
  // first make upper left 3x3
  for (i=0;i<=2;i++)
    {
      for (j=0;j<=2;j++)
	T(i,j)=A(i,j);
    }
  
  
  // put c into last row
  for (i=0;i<=2;i++)
    T(3,i)=c(i);
  
  // Lastly set element 3x3 to 1.0
  T(3,3)=1.0;
  
  return T;
}



perVector makeGamma(perMatrix N,perVector delta,percision tau,perVector Bstar,perMatrix Istar)
{
  // Create the gamma vector
  // See Freeman thesis, p.135 [3.32]
  
  perVector gamma(6,ColV);
  perVector tv1(6,ColV);
  percision tmp,M;

  M=1.0/Istar(2,2);

  tmp=M*(Bstar(2)+tau);
  gamma=N*delta;
  tv1=gamma-Bstar;

  gamma(0)=Istar(0,2)*tmp+tv1(0);
  gamma(1)=Istar(1,2)*tmp+tv1(1);
  gamma(2)=Istar(2,2)*tmp+tv1(2);
  gamma(3)=Istar(3,2)*tmp+tv1(3);
  gamma(4)=Istar(4,2)*tmp+tv1(4);
  gamma(5)=Istar(5,2)*tmp+tv1(5);
  //  original assumed symmetric matrix
  //  gamma(3)=Istar(2,3)*tmp+tv1(3);
  //  gamma(4)=Istar(2,4)*tmp+tv1(4);
  //  gamma(5)=Istar(2,5)*tmp+tv1(5);

  return gamma;
}




void symcheck66(perMatrix m,char *estring,int index=-99)
{
  // check and make sure matrix m is symmetric
  int i,j;
  for (i=0;i<6;i++)
    {
      for (j=i+1;j<6;j++)
	{
	  if (m(i,j)!=m(j,i))
	    {
	      if (index==-99)
		printf("$$$$$$$$$$ WARNING NONSYMMETRIC MATRIX %s:\n",estring);
	      else
		printf("$$$$$$$$$$ WARNING NONSYMMETRIC MATRIX %s (%d)\n",estring,index);
	      m.print();
	      getchar();
	      return;
	    }
	}
    }
}




void JessNormalize(perVectorR3 &vec)
{
  // normalize a 3vector
  percision len;

  len=sqrt(vec(0)*vec(0)+vec(1)*vec(1)+vec(2)*vec(2));
  vec(0)=vec(0)/len;
  vec(1)=vec(1)/len;
  vec(2)=vec(2)/len;
}



perMatrix ConvertEuler(percision e1,percision e2,percision e3,perMatrix &R)
{
  // Convert euler angles to a transformational matrix
  //  this is used in base computeDeAb() and camera update_after_draw()
  
  // compute the body to earth transform
  percision ce1,ce2,ce3;
  percision se1,se2,se3;

  // compute some shorthands
  ce1=cos(e1); ce2=cos(e2); ce3=cos(e3);
  se1=sin(e1); se2=sin(e2); se3=sin(e3);

  // okay compute DeAb;
  R(0,0)=ce1*ce2;
  R(0,1)=ce1*se2*se3-se1*ce3;
  R(0,2)=ce3*se2*ce1+se1*se3;
  //  R(1,0)=se3*ce2;               // ERROR in freeman thesis, see Spong
  R(1,0)=se1*ce2;
  R(1,1)=se1*se2*se3+ce1*ce3;
  //  R(1,2)=se3*se2*ce1-se1*se3;   // ERROR in freeman thesis, see Spong
  R(1,2)=se1*se2*ce3-ce1*se3;
  R(2,0)=-se2;
  R(2,1)=ce2*se3;
  R(2,2)=ce2*ce3;
  
  return R;
}












percision JessSecant(percision theta)
{
  return(1.0/cos(theta));
}


int Jsgn(percision val)
{
  if (val<0)
    return -1;
  else if (val>0)
    return 1;
  else
    return 0;
}


percision min3(percision a,percision b,percision c)
{
  // find the min of 3 numbers
  percision fretv;
  if (a<=b)
    fretv=a;
  else
    fretv=b;
  if (c<fretv)
    fretv=c;
  return (fretv);
}

percision max3(percision a,percision b,percision c)
{
  // find the min of 3 numbers
  percision fretv;
  if (a>=b)
    fretv=a;
  else
    fretv=b;
  if (c>fretv)
    fretv=c;
  return (fretv);
}


double rand01()
{
  // simple uniform random from 0 to 1
  // NOTE: drand48 seems to be returning large values instead of [0.0,1.0] so i am using rand()/RAND_MAX
  return (rand()/(double)RAND_MAX);
}











int stringindex(char **stringindex,char *instring)
{
  // string indexing routine, used to find the offset index of a string
  // inside and array of strings.  Used to simplify config files.
  // return -1 if you cant find a match.  Case insensitive
  int count;
  char string[MISCSTRLEN];
  
  strcpy(string,instring);
  jstrupr(string);
  for (count=0;stringindex[count][0]!='\0';++count)
    {
      if (strcmp(string,stringindex[count])==0)
	return count;
    }
  return -1;
}


void stringfromarray(char *string,char **stringindex)
{
  // Just string together all of the strings in the array, into
  //  comma separated 'string' for debug printing
  int count;
  
  strcpy(string,stringindex[0]);
  for (count=1;stringindex[count][0]!='\0';++count)
    {
      strcat(string,",");
      strcat(string,stringindex[count]);
    }
  return;
}


void cleanstring(char *string)
{
  // Remove any leading or trailing whitespaces on string
  int pos;
  char tempstring[BIGSTRLEN];
  
  //  printf("$entering cleanstring with '%s'\n",string);
  
  // First remove any at the end
  pos=strlen(string);
  while (pos>0)
    {
      if (string[pos-1]!=' ' && string[pos-1]!=13 && string[pos-1]!=10 && string[pos-1]!='\t' ||string[pos-1]==',')
	break;
      --pos;
    }
  string[pos]='\0';
  
  // Now remove any at begining
  pos=0;
  while (string[pos]!='\0')
    {
      if (string[pos]!=' ' && string[pos]!=13 && string[pos]!=10 && string[pos]!='\t' && string[pos]!=',')
	break;
      ++pos;
    }
  if (pos>0)
    {
      strcpy(tempstring,&string[pos]);
      strcpy(string,tempstring);
    }
}


void stringcrop(char *string, int len)
{
  // Make sure a string is less than some max size, if not then crop it.
  // This is a nescesary thing to do before copying a string to another data struct of limited space.
  if (strlen(string)>=len-1)
    string[len-1]='\0';
}


char *jstrdup(char *string)
{
  // My version of strdup, since lab c compiler doesn't hav it
  // allocate space for a duplicate of the string
  // copy the string to the new space
  // return address (char *) of new space
  int slen;
  char *newstring;
  
  // make sure we were passed a valid string
  if (string==(char *)NULL)
    return (char *)NULL;
  
  // Now allocate the new space
  slen=strlen(string);
  if ((newstring=(char *)malloc(slen+1))==(char *)NULL)
    return (char *)NULL;
  
  strcpy(newstring,string);
  return newstring;
}


int isnumber(char *string)
{
  // Is the string passed a valid floating point number
  percision dtemp;
  char *ecpoint;

  if (strcmp(string,"")==0)
    return NO;

  dtemp=(percision)strtod(string,&ecpoint);
  if (ecpoint!=(char *)NULL)
    {
      if (*ecpoint=='\0')
	return YES;
      // strtod() has told us there is an error in the number conversion
      //  so the string cannot be a pure number
      return NO;
    }
  else
    return YES;
}


void crchop(char *string)
{
  // Chop off any cr or lf at the end of a string
  int len;
  
  len=strlen(string);
  while (len>0)
    {
      if (string[len-1]==13 || string[len-1]==10 || string[len-1]==32 || string[len-1]=='\t')
	{
	  --len;
	  string[len]='\0';
	}
      else
	return;
    }
}


percision strnumber(char *string)
{
  // Convert an ascii string to a floating point number in percision percision
  percision dtemp;
  
  dtemp=(percision)strtod(string,(char **)NULL);
  return(dtemp);
}


void jstrupr(char *string)
{
  // our version of strtoupr, make a string all uppercase
  int len,count;
  char c;
  
  len=strlen(string);
  for (count=0;count<len;++count)
    {
      c=string[count];
      if (c>=97 && c<=122)
	string[count]=c-32;
    }
}








void fatalerr()
{
  printf("Exiting simulator.\n");
  exit(-1);
}


perMatrix compute_forceinertias(perMatrix I,char *string)
{
  // This is an experimental procedure designed to improve the
  //  forces generate by spring/mass ground interaction.
  // The idea is to scale up the contact impulse by the magnitude of the
  //  inertia of the objects. I is inertia in ground frame.
  perVector forcemod(6,ColV);
  
  forcemod.fill(0.0);
  forcemod(3)=1.0;
  forcemod(4)=1.0;
  forcemod(5)=1.0;
  forcemod=I*forcemod;

  return I;
}





void testea(percision e3,percision e2,percision e1)
{
  perMatrix eAe(3,3);
  perMatrix eAb(3,3);
  perMatrix bAe(3,3);

  perMatrix x(3,3);
  perMatrix y(3,3);
  perMatrix z(3,3);
  perMatrix xi(3,3);
  perMatrix yi(3,3);
  perMatrix zi(3,3);

  printf("performing a test of euler angle conversion inverse (%g,%g,%g)\n",e1,e2,e3);

  x.fill(0.0);
  y.fill(0.0);
  z.fill(0.0);
  xi.fill(0.0);
  yi.fill(0.0);
  zi.fill(0.0);

  x(0,0)=1.0;
  x(1,1)=cos(e1); x(1,2)=-sin(e1);
  x(2,1)=sin(e1); x(2,2)=cos(e1);

  y(0,0)=cos(e2); y(0,2)=sin(e2);
  y(1,1)=1.0;
  y(2,0)=-sin(e2); y(2,2)=cos(e2);

  z(0,0)=cos(e3); z(0,1)=-sin(e3);
  z(1,0)=sin(e3); z(1,1)=cos(e3);
  z(2,2)=1.0;

  e1*=-1.0; e2*=-1.0; e3*=-1.0;
  xi(0,0)=1.0;
  xi(1,1)=cos(e1); xi(1,2)=-sin(e1);
  xi(2,1)=sin(e1); xi(2,2)=cos(e1);

  yi(0,0)=cos(e2); yi(0,2)=sin(e2);
  yi(1,1)=1.0;
  yi(2,0)=-sin(e2); yi(2,2)=cos(e2);

  zi(0,0)=cos(e3); zi(0,1)=-sin(e3);
  zi(1,0)=sin(e3); zi(1,1)=cos(e3);
  zi(2,2)=1.0;

  eAb=z*y*x;
  eAb.print();

  //  bAe=xi*yi*zi;
  bAe=~eAb;
  eAe=eAb*bAe;

  printf("eAb:\n");
  eAb.print();
  printf("bAe:\n");
  bAe.print();
  printf("aAb * bAe :\n");
  eAe.print();
}
