//  Jesse Reichler, January 1996
//  Fred Delcomyn
//
//  robot.h
//  This file contains the class definition for the Robot class,
//   which contains the bulk of the mechanical/dynamic simulation code.
//  Robots are made up of a single base, to which is connected multiple
//   chains, as per decoupled tree structure of Freeman&Orin.
//  The Chain class is defined in a separate file.
//  
//
#ifndef Robot_defined
#define Robot_defined

#include "misc.def"
#include "thing.h"
#include "physobject.h"
#include "chain.h"
#include "base.h"



class Robot: public Thing
{
  friend class Chain;
  friend class Rot;
  friend class World;
private:
  class Base *base;
  int chains;
  class Chain *chain[MAX_CHAINS_PERROBOT];
public:
  Robot(const char *robotname,World *worldp);
  void done_construct();
  virtual ~Robot();
public:
  virtual void iterate(double deltat);
  void iteratebase(percision deltat);
  virtual void update(double deltat);
  virtual void updatefordraw();
  virtual void draw(class GrobVideoCamera *cam);
  void setbase (class Base *basep);
  void addchain (class Chain *chainp);
public:
  class Chain *lookupchain(char *chainname);
  void clearotherforces();
  virtual int thingtype() {return THING_ROBOT;};
  void resetbaseav();
public:
  virtual void movie_load(FILE *moviefp);
  virtual void movie_save(FILE *moviefp);
};


	



#endif
