#include "robot.h"
#include "grobcamera.h"
#include "physobject.h"
#include "link.h"
#include "chain.h"
#include "base.h"
#include "world.h"
#include "misc.def"




World *robotest()
{
  // test of building and drawing a robot
  World *worldp;
  Robot *robotp;
  Chain *chainp;
  Base *basep;
  Shape *shapep;
  Link *linkp;

  // start creation of a new world
  worldp=new World("TestWorld");
  
  {
    // start the creation of a new robot
    robotp=new Robot("testrobot",worldp);
    
    {
      // add a base to the robot
      //      basep=new Base("testbase",worldp,BASE_MOBILE);
      basep=new Base("testbase",worldp,BASE_FIXED);
      shapep=new Cube(30,.5,30);
      basep->setshape(shapep);
      robotp->setbase(basep);
      
      // start the creation of a chain
      chainp=new Chain("legone",worldp,robotp);
      
      {
	// add a link to the chain
	linkp=new Link("firstlink",worldp);
	shapep=new Legcone(3,2,20,0,1,8,0);
	linkp->setshape(shapep);
	linkp->setdh(0,0,8,0);
	linkp->done_construct();
	chainp->addlink(linkp);
      }
      {
	// add another link to the chain
	linkp=new Link("secondlink",worldp);
	shapep=new Legcone(2,1,13,0,1,8,0);
	linkp->setshape(shapep);
	linkp->setdh(20,0,8,1);
	linkp->done_construct();
	chainp->addlink(linkp);
      }
      {
	// add third link to the chain
	linkp=new Link("thirdlink",worldp);
	shapep=new Legcone(1,.5,7,0,1,8,1);
	linkp->setshape(shapep);
	linkp->setdh(13,0,8,1);
	linkp->done_construct();
	chainp->addlink(linkp);
      }
      
      // end constrcution of the chain and add it to the robot
      chainp->done_construct();
      robotp->addchain(chainp);
    }
    
    // end constrcution of the robot
    robotp->done_construct();
  }

  // end construction of the world
  worldp->done_construct();

  return worldp;
}



