//  Jesse Reichler, February 1996
//  Fred Delcomyn
//
//  rot.h
//  This file contains the class definition for the Rot class,
//   which implements the Dennavit Hartenberg transformation matrices that
//   allow the expression of one link in the frame of another.
//  It is based on code from legsim, and [Craig 1986].
//  
//
#ifndef Rot_defined
#define Rot_defined


#include "misc.def"
#include "matrixinc.h"

class Rot
{
   friend class Chain;
   class Chain *chainp;
   class World *worldp;
   perMatrix **ROTdataX;     // 6x6 ;
   perMatrix **ROTdataT;     // 4x4 ;
 public:
   void allocate(class Chain *ichainp, class World *iworldp);
   void initialize();
   void deallocate();
   void update();
   perMatrix DXA33(int indexto,int indexfrom);
   perMatrix DX66(int indexto,int indexfrom);
   perMatrix DX66i(int indexto,int indexfrom);
   perMatrix DT44(int indexto,int indexfrom);
   perMatrix DTA33(int indexto,int indexfrom);
   perVector DTp(int indexto,int indexfrom);
   perMatrix DXcongru(int indexto,int indexfrom,perMatrix N);
   void verify();
};



#endif
	
