// swbiobot.h
// This file describes the biobot robot classes

#ifndef INC_swbioboth
#define INC_swbioboth

#include "cfpinc.h"

// biobot files
#include "world.h"
#include "robot.h"
#include "base.h"
#include "chain.h"
#include "physobject.h"
#include "link.h"
#include "experiment.h"





class SWbiobot_obj: public CfpObject
{
private:
  World *worldp;
  Robot *robotp;
  Chain *chainp;
  Base *basep;
  Shape *shapep;
  Link *linkp;
  Physicalobject *physobjp;
public:
  SWbiobot_obj *dummyp;
  static int dummyi;
private:
  CfpVAccessor *pretrigger;
  CfpVAccessor *clocktrigger;
public:
  SWbiobot_obj(bool registerme=true) : CfpObject(){if (registerme) GlobalFactoryreg(this,"Biobot");};
  SWbiobot_obj(Configpp *cfpfp,CfpClass *inclassp,string oname);
public:
  virtual void registerwrappers(CfpFactory *sfactp);
  CfpObject *makenew(CfpClass *inclassp,string objname);		// generic makenew
  CfpVal done();							// any return value?
  void destruct();							// deinstatiate wrapped obj
  void construct();							// no arg constructor of wrappedobj;
public:
  void preinterpret(CfpClass *inclassp);				// called once per class
  void postinterpret(CfpClass *inclassp);				// called once per class
private:
  void addargs_physical(CfpClass *newclassp);				// add default args for phys. objects
  void addargs_shape(CfpClass *newclassp);				// add default args for shape objects;
  void loadmeshdata();                                                  // load mesh data for a mesh shape
private:
  void construct_experiment();						// build the biobot object
  void construct_world();						// build the biobot object
  void construct_robot();						// build the biobot object
  void construct_base();						// build the biobot object
  void construct_chain();						// build the biobot object
  void construct_link();						// build the biobot object
  void construct_shape();						// build the biobot object
  void construct_object();						// build the biobot object
  void addaccessors();							// add any variable accessors
private:
  void setphys();  
private:
  void initialize_simulation();						// called when library is registered
  void worlditerate();
public:
  bool moviesave(FILE *fp);
  bool movieload(FILE *fp);
  void setmovieplaybackflag(bool inflag=true);
  static int sayfive() {return 5;};
  static int dummyvar;
};








#endif
