//  Jesse Reichler, January 1996
//  Fred Delcomyn
//
//  thing.h
//  This file contains the class definition for the Thing class,
//   which is really just used as a superclass for all other simulation "objects".
//  
//
#ifndef Thing_defined
#define Thing_defined

#include "misc.def"
#include "grobcamera.h"

#include <stdio.h>





// ----------------------------------------------------------------------------------------------
// -- Base Thing class
// ----------------------------------------------------------------------------------------------

class Thing
{
private:
  int worldowned;
public:
  char name [NAMESTRLEN];
  class World *homeworld;
public:
  virtual ~Thing();
  void setthing(const char *thingname, class World *worldp,int wowned);
public:
  int worlditerate() {return worldowned;};
  int worldupdate() {return worldowned;};
  int worlddraw() {return worldowned;};
  int worlddelete() {return worldowned;};
public:
  virtual void iterate(double deltat) {;};
  virtual void update(double deltat) {;};
  virtual void updatefordraw() {;};
  virtual void draw(class GrobVideoCamera *cam) {;};
public:
  virtual int shapetype() {return SHAPE_NOSHAPE;};
  virtual int thingtype() {return THING_DEFAULT;};
  virtual int isphys() {return NO;};
public:
  virtual void movie_load(FILE *moviefp);
  virtual void movie_save(FILE *moviefp);
};


#endif
