// infactory.h
// The DatafactoryIn classes


// forward declarations
class DatInStore;
class DatInFile;

#ifndef infactoryh_defined
#define infactoryh_defined

#include "datafactory.h"

#include <stdlib.h>
#include <stdio.h>
#include <string>



// ---------------------------------------------------------------------------------------
// -- DatInStore
// ---------------------------------------------------------------------------------------
//: DatInStore holds information fo a single data "variable" to be used for reading data files
//  It is a helper class for DataInFile

class DatInStore : public DatStore
{
  friend class DatafactoryIn;
private:
  CfpVal val[3];
private:
  SampleInType sampmode;
public:
  DatInStore(CfpVAccessor *invac,Datafactory *indfactp,SampleInType insmode,int inindex);
public:
  void update(int writeindex);
};




// ---------------------------------------------------------------------------------------
// -- DatafactoryIn
// ---------------------------------------------------------------------------------------

class DatafactoryIn : public Datafactory
{
private:
  SampleInType smode;
  bool recycle;
  double modulus,delay;
private:
  int readindex,writeindex;
  int lowerindex,upperindex;
  double lowervalue,uppervalue;
  double curvalue;
  bool punctuate;
public:
  bool validvals;
  int curline;
  int numlines;
  DatInStore *indexp;
public:   
  DatafactoryIn(Configpp *cfpp,int insamplerate,bool inrecycle);
  ~DatafactoryIn();
  virtual string gettype() {return "In";};
public:
  DatStore *getindex(){return indexp;};
  void setindex(DatInStore *inindexp,double inmod,double indelay){indexp=inindexp;modulus=inmod;delay=indelay;};
  CfpVal *getivalp(int index,int subindex);
  CfpVal *getivalp(int subindex);
public:
  virtual void start();
  virtual void update();
private:
  void output();
  void computevals();
  void reset();
  bool loadsurrounds();
  bool initialread();
  void makewriterow();
  void makerowinterp();
};







#endif
