// outfactory.h
// The DatafactryOut classes

// forward declarations
class DatOutStore;
class DataOutFile;

#ifndef outfactoryh_defined
#define outfactoryh_defined

#include "datafactory.h"

#include <stdlib.h>
#include <stdio.h>
#include <string>


// ---------------------------------------------------------------------------------------
// -- DatOutStore
// ---------------------------------------------------------------------------------------
//: DatOutStore holds information fo a single data "variable" to be used for writing data files.
//  It is a helper class for DataOutFile

class DatOutStore : public DatStore
{
  friend class DatafactoryOut;  
private:
  CfpVal storeval;
private:
  SampleOutType sampmode;
public:
  DatOutStore(CfpVAccessor *invac,Datafactory *indfactp,SampleOutType insmode, int inindex);
public:
  void update();
};






// ---------------------------------------------------------------------------------------
// -- DatafactoryOut
// ---------------------------------------------------------------------------------------

class DatafactoryOut : public Datafactory
{
  friend class DatOutStore;
public:
  DatafactoryOut(Configpp *cfpp, int insamplerate);
  ~DatafactoryOut();
public:
  virtual void update();
  virtual void start();
  virtual void finish();
public:
  virtual string gettype() {return "Out";};
};




#endif
