// swfltk.C

#include "cfpinc.h"
#include "swfltk.h"
#include "JRutils.h"

#include <unistd.h>
#include <stdlib.h>


//test
extern float testtextscale;





//--------------------------------------------------------------------------------
//---- SWfltk_modal::SWfltk_modal() ----------------------------------------------------------
//--------------------------------------------------------------------------------

SWfltk_modal::SWfltk_modal(Configpp *cfpfp,CfpClass *inclassp,string oname)
  :CfpObject(cfpfp,inclassp,oname)
{
  // this is the constructor that gets called every time the user creates a new
  // instantiated object of the class.
  // This function and makenew, the next, are partners.
}



//--------------------------------------------------------------------------------
//---- SWfltk_modal::makenew() ---------------------------------------------------------
//--------------------------------------------------------------------------------

CfpObject *SWfltk_modal::makenew(CfpClass *inclassp,string objname)
{
  // create a new instance of ourselves, the wrapper.
  // Important: instantiating the wrapped class will come later (in function 'construct').
  return (new SWfltk_modal(configppp,inclassp,objname));
}







//--------------------------------------------------------------------------------
//---- SWfltk_modal() ------------------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_modal::registerwrappers(CfpFactory *sfactp)
{
  // this is the constructor that gets called ONCE when the class is registered with the factory.
  CfpClass *newclassp;

  // register the announcement class (fl_message,fl_alert)
  newclassp=sfactp->registerclass("Gui","Announcement.Info",this);
  newclassp->addarg("message","variable 'message' not assigned!","text of the message");
  newclassp=sfactp->registerclass("Gui","Announcement.Alert",this);
  newclassp->addarg("message","variable 'message' not assigned!","text of the message");

  // register the question class (fl_ask,fl_choice,fl_input,fl_password)
  newclassp=sfactp->registerclass("Gui","Query.Yesno",this);
  newclassp->addarg("message","variable 'message' not assigned!","text of the question");
  newclassp=sfactp->registerclass("Gui","Query.String",this);
  newclassp->addarg("message","variable 'message' not assigned!","text of the question");
  newclassp->addarg("secret","false","should answer be scrambled on screen");
  newclassp->addarg("default","","default answer");

  // register the filechoosern class (fl_file_chooser)
  newclassp=sfactp->registerclass("Gui","Filechooser",this);
  newclassp->addarg("title","choose the file to load","title of file chooser window");
  newclassp->addarg("pattern","*.cfp","pattern to match against files shown");
}





//--------------------------------------------------------------------------------
//---- SWfltk_modal::construct() ------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_modal::construct()
{
  // instantiate the wrapped object.  this is where we actually do late (lazy) instantiation.
  // if we are a wrapper for another class, we would allocate that target wrapped class here.
  // and save it to a local variable.  otherwise this is its own wrapper.
  // the args will have been filled by now.
  CfpVAccessor *valac;
  string stringans="";
  string tempstring;
  const char *stringansp;
  int choiceans;

  // create the wrapped object

  // announcements
  if (baseclass()=="Announcement")
    {
      if (subclass()=="Info")
	{
	  text=lookuparg("message")->getstr();
	  fl_message(text.c_str());
	}
      else if (subclass()=="Alert")
	{
	  text=lookuparg("message")->getstr();
	  fl_alert(text.c_str());
	}
    }
  else if (baseclass()=="Query")
    {
      if (subclass()=="Yesno")
	{
	  text=lookuparg("message")->getstr();
	  choiceans=fl_ask(text.c_str());
	  retval=CfpVal(choiceans);
	}
      else if (subclass()=="String")
	{
	  text=lookuparg("message")->getstr();
	  if (argdefined("default"))
	    {
	      tempstring=argval("default");
	      if ((string)argval("secret")=="true")
		stringansp=fl_password(text.c_str(),tempstring.c_str());
	      else
		stringansp=fl_input(text.c_str(),tempstring.c_str());
	    }
	  else
	    {
	      if (argval("secret").get_string()=="true")
		stringansp=fl_password(text.c_str());
	      else
		stringansp=fl_input(text.c_str());
	    }
	  if (stringansp!=NULL)
	    stringans+=stringansp;
	  retval=CfpVal(stringans);
	}
    }
  else if (classname()=="Filechooser")
    {
      text=lookuparg("title")->getstr();
      stringansp=fl_file_chooser(text.c_str(),(lookuparg("pattern")->getstr()).c_str(),NULL);
      if (stringansp!=NULL)
	stringans+=stringansp;
      retval=CfpVal(stringans);
    }

  // set the instantiated flag
  instantiated=true;
}








//--------------------------------------------------------------------------------
//---- SWfltk_modal::done() ------------------------------------------------------------
//--------------------------------------------------------------------------------

CfpVal SWfltk_modal::done()
{
  // the object is done (ie no more children) return any return value
  return retval;
}




//--------------------------------------------------------------------------------
//---- SWfltk_modal::postinterpret() ---------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_modal::postinterpret(CfpClass *inclassp)
{
  // this function is called ONCE for each class, after interpretation has completed
  if (inclassp->getname()=="Announcement.Info")
    {
      // the test above is a kludge for only running this once
      SWfltk_guipending *guitimerp=new SWfltk_guipending(configppp);
      configppp->addtimer(guitimerp);
    }
}




//--------------------------------------------------------------------------------
//---- SWfltk_modal::destruct() -------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_modal::destruct()
{
  // de-instantiate the wrapped object.
  // we wrap ourselves so there is no need to delete any 'wrapped class', just set the instantiated flag to false
  instantiated=false;
}





































































//--------------------------------------------------------------------------------
// static member var initialization
//--------------------------------------------------------------------------------
SWfltk_glinitWindow *SWfltk_widget::glinitwin=NULL;





//--------------------------------------------------------------------------------
//---- SWfltk_widget::SWfltk_widget() --------------------------------------------
//--------------------------------------------------------------------------------

SWfltk_widget::SWfltk_widget(Configpp *cfpfp,CfpClass *inclassp,string oname)
  :CfpObject(cfpfp,inclassp,oname)
{
  // this is the constructor that gets called every time the user creates a new
  // instantiated object of the class.
  // This function and makenew, the next, are partners.

  // initialize
  parentp=NULL;
  localp=NULL;
  placex=0;placey=0;
  bigx=0;bigy=0;
  leftspace=0;rightspace=0;topspace=0;bottomspace=0;
  textpos="center";
  textsize=12;
  spacerx=8;
  spacery=8;
  accessorp=NULL;
}



//--------------------------------------------------------------------------------
//---- SWfltk_widget::makenew() ---------------------------------------------------------
//--------------------------------------------------------------------------------

CfpObject *SWfltk_widget::makenew(CfpClass *inclassp,string objname)
{
  // create a new instance of ourselves, the wrapper.
  // Important: instantiating the wrapped class will come later (in function 'construct').
  CfpObject *newp=NULL;

  newp=new SWfltk_widget(configppp,inclassp,objname);
  return newp;
}






//--------------------------------------------------------------------------------
//---- SWfltk_widget() -----------------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::registerwrappers(CfpFactory *sfactp)
{
  // this is the constructor that gets called ONCE when the class is registered with the factory.
  CfpClass *newclassp;

  // register the window class (FL_Window)
  newclassp=sfactp->registerclass("Gui","Window",this);
  addargs_label(newclassp);
  addargs_widget(newclassp,"","topleft");

  // register our gl panel class
  newclassp=sfactp->registerclass("Gui","Window.Gl",this);
  addargs_label(newclassp);
  addargs_widget(newclassp,"","topleft");

  // register our gl grobcamera panel class
  newclassp=sfactp->registerclass("Gui","Window.Grob",this);
  newclassp->addvar("zoom","",false,"zoom factor");
  newclassp->addvar("distance","100",false,"");
  newclassp->addvar("aperture",".3",false,"");
  newclassp->addvar("refreshrate","1",false,"refresh rate of window (how often it updates)");
  newclassp->addvar("detail","",false,"detail level");
  newclassp->addvar("axes","",false,"show axes?");
  newclassp->addvar("boundingbox","",false,"show bounding box?");
  newclassp->addvar("nextview","",false,"function to switch to next view");
  newclassp->addvar("euler1","",false,"camera orientation angle1");
  newclassp->addvar("euler2","",false,"camera orientation angle2");
  newclassp->addvar("euler3","",false,"camera orientation angle3");
  newclassp->addvar("textscale","",false,"test of text scale");
  newclassp->addvar("xdolly","",false,"camera focus x");
  newclassp->addvar("ydolly","",false,"camera focus x");
  newclassp->addvar("zdolly","",false,"camera focus x");
  newclassp->addvar("view","",false,"view number");
  newclassp->addarg("drawer","",false,"object which draws the contents");
  addargs_label(newclassp);
  addargs_grob(newclassp);
  addargs_widget(newclassp,"","topleft");

  // register our gl grobcamera help class for views
  newclassp=sfactp->registerclass("Gui","Cameraview",this);
  newclassp->addarg("e1","",false,"e1 angle");
  newclassp->addarg("e2","",false,"e2 angle");
  newclassp->addarg("e3","0",false,"e3 angle");
  newclassp->addarg("zoom","1",false,"zoom factor");
  newclassp->addarg("ydolly","0",false,"y dolly");

  // register button class
  newclassp=sfactp->registerclass("Gui","Button",this);
  addargs_label(newclassp);
  addargs_widget(newclassp,"12","center");
  addargs_callback(newclassp);

  // register button.light class
  newclassp=sfactp->registerclass("Gui","Button.Light",this);
  addargs_label(newclassp);
  addargs_widget(newclassp,"12","center");
  addargs_callback(newclassp);

  // register valuator.slider class
  newclassp=sfactp->registerclass("Gui","Valuator.Slider",this);
  addargs_label(newclassp);
  addargs_widget(newclassp,"","left");
  newclassp->addarg("min","-4",true,"minimum value");
  newclassp->addarg("max","4",true,"maximum value");
  newclassp->addarg("stepsize","",true,"step increment");
  newclassp->addarg("value","",true,"initial value");
  addargs_callback(newclassp);

  // register menu.bar class
  newclassp=sfactp->registerclass("Gui","Menu.Bar",this);
  addargs_label(newclassp);
  addargs_widget(newclassp,"","left");

  // register menu.button class
  newclassp=sfactp->registerclass("Gui","Menu.Button",this);
  newclassp->addarg("show","label",false,"what to show on the front of the button (value|label|valuelabel)");
  addargs_label(newclassp);
  addargs_widget(newclassp,"","left");

  // register menu.mouse class
  newclassp=sfactp->registerclass("Gui","Menu.Mouse",this);
  addargs_label(newclassp);

  // register submenu class
  newclassp=sfactp->registerclass("Gui","Submenu",this);
  addargs_label(newclassp);

  // register menuitem class
  newclassp=sfactp->registerclass("Gui","Menuitem",this);
  newclassp->addarg("id","",false,"the callback id");
  addargs_label(newclassp);
  addargs_callback(newclassp);

  // register menuitem.toggle class
  newclassp=sfactp->registerclass("Gui","Menuitem.Toggle",this);
  newclassp->addarg("id","",false,"the callback id");
  addargs_label(newclassp);
  addargs_callback(newclassp);

  // register menuitem.radio class
  newclassp=sfactp->registerclass("Gui","Menuitem.Radio",this);
  newclassp->addarg("id","",false,"the callback id");
  addargs_label(newclassp);
  addargs_callback(newclassp);

  // register menuitem.divider class
  newclassp=sfactp->registerclass("Gui","Menuitem.Divider",this);

  // fltk recommended initialization
  Fl::visual(FL_DOUBLE|FL_INDEX);

  // initialize gl
  glstartcheck();
}












//--------------------------------------------------------------------------------
//---- SWfltk_widget::construct() ------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::construct()
{
  // instantiate the wrapped object.  this is where we actually do late (lazy) instantiation.
  // if we are a wrapper for another class, we would allocate that target wrapped class here.
  // and save it to a local variable.  otherwise this is its own wrapper.
  // the args will have been filled by now.
  CfpVAccessor *varp;

  if (baseclass()=="Window")
    construct_window();
  else if (baseclass()=="Button")
    construct_button();
  else if (baseclass()=="Valuator")
    construct_valuator();
  else if (classname()=="Cameraview")
    construct_cameraview();
  else if (isa("Menu Submenu Menuitem"))
    construct_menu();


  // add accessors
  addaccessors();


  // set the instantiated flag
  instantiated=true;
}



//--------------------------------------------------------------------------------
//---- SWfltk_widget::done() -----------------------------------------------------
//--------------------------------------------------------------------------------

CfpVal SWfltk_widget::done()
{
  // the object is done (ie no more children) return any return value

  // if it's a window, end it and show it
  if (baseclass()=="Window")
    {
      if (!parentp)
	{
	  // this is a root window so we show it and then its children
	  windowp->end();
	  showwindow(windowp);
	}
      else
	{
	  // when we finish with a child window, we place it on the parent, which may resize
	  guessposition();
	  windowp->position(xpos,ypos);
	  // now add a nice bordered box to the subwindow
	  if (subclass()=="Gl" || subclass()=="Grob")
	    {
	      Fl_Group::current(parentp->getwinp());
	      boxp=new Fl_Box(FL_DOWN_FRAME,xpos-2,ypos+-2,width+4,height+4,JRstradr(&label));
	      runargs_align(boxp,textpos);
	    }
	  else
	    {
	      Fl_Group::current(parentp->getwinp());
	      boxp=new Fl_Box(FL_ENGRAVED_FRAME,xpos-3,ypos-3,width+6,height+6,JRstradr(&label));
	      runargs_align(boxp,textpos);
	    }
	  windowp->end();
	}
      if (subclass()=="Grob")
	{
	  // tell the grob camera about it's size and location
	  SWfltk_grobCamera *gcp= (SWfltk_grobCamera *)windowp;
	  gcp->setwinsize(gcp->w(),gcp->h(),gcp->x(),gcp->y());
	}
    }
  else if (baseclass()=="Submenu")
    {
      SWfltk_widget *swp;
      swp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Submenu",false));
      if (swp)
	{
	  if (swp->menuindex==-1 && menuindex>-1)
	    swp->menuindex=menuindex-1; // a kludge to guess index of submenu header when we add first entry
	}
    }

  // this should probably be moved somewhere else, but for now...
  connectwires();

  return retval;
}






//--------------------------------------------------------------------------------
//---- SWfltk_widget::destruct() -------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::destruct()
{
  // de-instantiate the wrapped object.
  // we wrap ourselves so there is no need to delete any 'wrapped class', just set the instantiated flag to false
  instantiated=false;
}















//--------------------------------------------------------------------------------
//---- SWfltk_widget::guessextent() ----------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::guessextent(string intext)
{
  // guess loc and size of widget
  guesssize(intext);
  guessposition();
}




//--------------------------------------------------------------------------------
//---- SWfltk_widget::guesssize() ------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::guesssize(string intext)
{
  // guess size of widget if user does not specify one, otherwise use users
  int gwidth=width;
  int gheight=height;
  int gleftspace=leftspace;
  int grightspace=rightspace;
  int gtopspace=topspace;
  int gbottomspace=bottomspace;
  int uwidth=-1;
  int uheight=-1;
  int uleftspace=-1;
  int urightspace=-1;
  int utopspace=-1;
  int ubottomspace=-1;
  // the growborder flags determine whether or not adding things like labels should grow the widget size
  // (as in adding a label to the side of a button) or not (as in adding a label to the left of a slider).
  bool growborderx=false;
  bool growbordery=false;

  // get any user values
  if (argdefined("width"))
    uwidth=argval("width");
  if (argdefined("height"))
    uheight=argval("height");
  if (argdefined("leftspace"))
    uleftspace=argval("leftspace");
  if (argdefined("rightspace"))
    urightspace=argval("rightspace");
  if (argdefined("topspace"))
    utopspace=argval("topspace");
  if (argdefined("bottomspace"))
    ubottomspace=argval("bottomspace");

  if (baseclass()=="Window")
    {
      if (!parentp)
	{
	  // a root window
	  growborderx=growbordery=true;
	  gwidth=300;
	  if (subclass()=="Gl" || subclass()=="Grob")
	    gheight=300;
	  else
	    gheight=30;
	}
      else
	{
	  // subwindow
	  growborderx=growbordery=false;
	  gwidth=parentp->getplacewidth();
	  if (subclass()=="Gl" || subclass()=="Grob")
	    {
	      // make gl windows square
	      gheight=parentp->getplaceheight();
	      if (gheight<gwidth)
		gheight=gwidth;
	    }
	  else
	    gheight=30;

	  // adjust based on label space
	  gleftspace=grightspace=4;
	  gtopspace=gbottomspace=4;
	  guesslabelspace(intext,gwidth,gheight,gleftspace,grightspace,gtopspace,gbottomspace);
	}
    }
  else if (baseclass()=="Button")
    {
      growborderx=growbordery=true;
      int minlen=10;
      if (intext.length()<minlen)
	intext.append(minlen-intext.length(),' ');
      guesstextsize(intext,textsize,gwidth,gheight);
      gheight+=14;
      if (subclass()=="Light")
	gwidth+=25;
      else
	gwidth+=10;
    }
  else if (classname()=="Valuator.Slider")
    {
      // slider labels are not part of allocated widget (too bad), so we must indent it ourselves
      growborderx=false;
      growbordery=true;
      if (textpos=="bottom")
	{
	  gwidth=(parentp->getplacewidth());
	  gheight=textsize+6;
	}
      else 
	{
	  gwidth=(parentp->getplacewidth());
	  gheight=textsize+2;
	}
      // adjust based on label space
      guesslabelspace(intext,gwidth,gheight,gleftspace,grightspace,gtopspace,gbottomspace);
    }
  else if (baseclass()=="Menu")
    {
      growborderx=growbordery=true;
      if (subclass()=="Bar")
	{
	  gwidth=parentp->getwidth();
	  gheight=30;
	}
      else if (subclass()=="Mouse")
	{
	  gwidth=parentp->getwidth();
	  gheight=parentp->getwidth();
	}
      else if (subclass()=="Button")
	{
	  // menu buttons
	  int minlen=10;
	  if (intext.length()<minlen)
	    intext.append(minlen-intext.length(),' ');
	  guesstextsize(intext,textsize,gwidth,gheight);
	  gheight+=14;
	  if ((string)argval("show")=="value")
	    {
	      // we need to add extra space for the label
	      gleftspace+=gwidth;
	      // adjust based on label space
	      guesslabelspace(intext,gwidth,gheight,gleftspace,grightspace,gtopspace,gbottomspace);
	    }
	  else
	     gwidth+=32;
	}
    }

  // should we use user values or our guessed ones?
  if (uwidth!=-1)
    width=uwidth;
  else
    width=gwidth;
  if (uheight!=-1)
    height=uheight;
  else
    height=gheight;
  if (uleftspace!=-1)
    leftspace=uleftspace;
  else
    leftspace=gleftspace;
  if (urightspace!=-1)
    rightspace=urightspace;
  else
    rightspace=grightspace;
  if (utopspace!=-1)
    topspace=utopspace;
  else
    topspace=gtopspace;
  if (ubottomspace!=-1)
    bottomspace=ubottomspace;
  else
    bottomspace=gbottomspace;

  // grow size if appropriate
  if (!growborderx)
    width-=(leftspace+rightspace);
  if (!growbordery)
    height-=(topspace+bottomspace);
}




//--------------------------------------------------------------------------------
//---- SWfltk_widget::guessposition() --------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::guessposition()
{
  // guess loc of widget if user does not specify
  int gxpos=-1;
  int gypos=-1;
  int uxpos=-1;
  int uypos=-1;

  // get any user values
  if (argdefined("xpos"))
    uxpos=argval("xpos");
  if (argdefined("ypos"))
    uypos=argval("ypos");

  if (baseclass()=="Window")
    {
      if (parentp==NULL)
	{
	  gxpos=-1;
	  gypos=-1;
	}
      else
	parentp->place(this,gxpos,gypos,width,height,leftspace,rightspace,topspace,bottomspace);
    }
  else if (baseclass()=="Menu")
    {
      if (subclass()=="Bar")
	{
	  // put the menubar in upper left corner of parent window
	  parentp->place(this,gxpos,gypos,width,height,leftspace,rightspace,topspace,bottomspace,0,0);
	}
      else if (subclass()=="Mouse")
	{
	  // by default mouse menu context areas cover the whole window
	  gxpos=gypos=0;
	}
      else
	{
	  // it's a button type so we ask our parent
	  if (parentp)
	    parentp->place(this,gxpos,gypos,width,height,leftspace,rightspace,topspace,bottomspace);
	  else
	    gxpos=gypos=0;
	}
    }
  else if (baseclass()=="Submenu" || baseclass()=="Menuitem")
    {
      // these widgets are kept inside others so we don't need space on parent
      // these values are ignored
      gxpos=gypos=0;
    }
  else if (parentp)
    {
      // we are a sub object of a parent, so we ask the parent where to put us
      // note: this consumes the space on the parent
      parentp->place(this,gxpos,gypos,width,height,leftspace,rightspace,topspace,bottomspace);
    }
  else
    {
      // how did this happen?
    }

  // should we use user values or our guessed ones?
  if (uxpos!=-1)
    xpos=uxpos;
  else
    xpos=gxpos;
  if (uypos!=-1)
    ypos=uypos;
  else
    ypos=gypos;

  if (xpos>=0)
    xpos+=leftspace;
  if (ypos>=0)
    ypos+=topspace;
}






//--------------------------------------------------------------------------------
//---- SWfltk_widget::place() ----------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::place(CfpObject *childp,int &inxpos,int &inypos,int inwidth,int inheight,int lspc,int rspc,int tspc,int bspc,int bspacerx,int bspacery)
{
  // return a place on our window and update our place counters
  int fullwidth=lspc+inwidth+rspc;
  int fullheight=tspc+inheight+bspc;
  int newwidth,newheight;
  
  // if this is first call, we fix the initialization
  // also add a kludge for things like menus which want to override any window border spacing
  if (bspacerx==-1)
    {
      bspacerx=spacerx;
      if (placex<bspacerx && bigy==0)
	placex=bspacerx;
    }
  if (bspacery==-1)
    {
    bspacery=spacery;
    if (placey<bspacery && bigy==0)
      placey=bspacery;
    }

  // make sure window is wide enough
  if (bspacerx+fullwidth+bspacerx>width)
    {
      if (baseclass()=="Window")
	{
	  width=bspacerx+fullwidth+bspacerx;
	  windowp->size(width,height);
	}
    }

  // adjust placement
  if (placex+fullwidth>width)
    {
      placex=bspacerx;
      placey=placey+bigy+bspacery;
      bigy=0;
    }

  // make sure window is high enough
  if (placey+fullheight+bspacery>height)
    {
      if (baseclass()=="Window")
	{
	  height=placey+fullheight+bspacery;
	  windowp->size(width,height);
	}
    }
  
  // set the position of child widget
  inxpos=placex;
  inypos=placey;

  // update placement vars
  placex+=fullwidth+bspacerx;
  if (fullheight>bigy)
    bigy=fullheight;
}




//--------------------------------------------------------------------------------
//---- SWfltk_widget::guesstextsize() --------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::guesstextsize(string intext,int pointsize,int &textwidth,int &textheight)
{
  // guess how big a window would be needed to hold the text of the specified size
  if (intext=="")
    {
      textheight=0;
      textwidth=0;
      return;
    }

  textwidth=intext.length()*((pointsize/2)+1);
  textheight=pointsize;
}


//--------------------------------------------------------------------------------
//---- SWfltk_widget::guesstextwidth() -------------------------------------------
//--------------------------------------------------------------------------------

int SWfltk_widget::guesstextwidth(string intext,int pointsize)
{
  // guess how big a window would be needed to hold the text of the specified size
  int textwidth,textheight;
  guesstextsize(intext,pointsize,textwidth,textheight);
  return textwidth;
}

//--------------------------------------------------------------------------------
//---- SWfltk_widget::guesstextheight() ------------------------------------------
//--------------------------------------------------------------------------------

int SWfltk_widget::guesstextheight(string intext,int pointsize)
{
  // guess how big a window would be needed to hold the text of the specified size
  int textwidth,textheight;
  guesstextsize(intext,pointsize,textwidth,textheight);
  return textheight;
}




//--------------------------------------------------------------------------------
//---- SWfltk_widget::guesslabelspace() ------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::guesslabelspace(string intext,int &gwidth,int &gheight,int &gleftspace,int &grightspace,int &gtopspace,int &gbottomspace)
{
  // adjust the widget size and position based on where the label will be

  if (parentp!=NULL && intext!="")
    {
      if (textpos=="left")
	gleftspace+=guesstextwidth(intext,textsize);
      else if (textpos=="bottom")
	gbottomspace+=guesstextheight(intext,textsize)+2;
      else if (textpos=="topleft")
	gtopspace+=guesstextheight(intext,textsize);
    }
}






//--------------------------------------------------------------------------------
//---- SWfltk_widget::showwindow() ------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::showwindow(Fl_Window *winp)
{
  Fl_Widget* childp;
  int count;
  int widgets;

  // show the widget
  winp->show();

  // if it's a group, show all its children
  // note this uses a semi-documented rtti feature of fltk (type() see file FL/Fl_Group.cxx)
  widgets=winp->children();
  for (count=0;count<widgets;++count)
    {
      childp=winp->child(count);
      if (childp->type()>=FL_WINDOW)
	{
	  // the child is a subwindow, so tell it to showgroup
	  showwindow((Fl_Window *)childp);
	}
      else
	childp->show();
    }
}












//--------------------------------------------------------------------------------
//---- SWfltk_widget::addargs_widget() -------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::addargs_widget(CfpClass *newclassp,string sizestr,string posstr)
{
  // add some default args that go with most widgets
  newclassp->addarg("xpos","",false,"x position of widget");
  newclassp->addarg("ypos","",false,"y position of widget");
  newclassp->addarg("width","",false,"width dimension of widget");
  newclassp->addarg("height","",false,"hieght dimension of widget (may be grown)");
  newclassp->addarg("textsize",sizestr,true,"size of the text");
  newclassp->addarg("textpos",posstr,true,"where to put the text/label (left or below)");
}



//--------------------------------------------------------------------------------
//---- SWfltk_widget::addargs_label() --------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::addargs_label(CfpClass *newclassp)
{
  // add some default args that go with most widgets that have labels
  newclassp->addarg("label","",false,"label on the widget");
}



//--------------------------------------------------------------------------------
//---- SWfltk_widget::addargs_grob()
//--------------------------------------------------------------------------------

void SWfltk_widget::addargs_grob(CfpClass *newclassp)
{
  // add grob args
  newclassp->addarg("title","",false,"title IN videocamera window");
  newclassp->addarg("subtitle","",false,"subtitle IN videocamera window");
}



//--------------------------------------------------------------------------------
//---- SWfltk_widget::addargs_callback() -----------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::addargs_callback(CfpClass *newclassp)
{
  // add args for a callback

  // this is the arg the user can specify (old version)
  newclassp->addarg("callback","",false,"callback for the widget value");
  // this is the dynamic variable which wires should be attached to
  newclassp->addvar("valueout","",false,"callback for the widget value");
  newclassp->addvar("valuein","",false,"callback for the widget value");
  newclassp->addarg("from","valueout",false,"default 'from' assignment for Wires declared inside this object");
  newclassp->addarg("to","valuein",false,"default 'to' assignment for Wires declared inside this object");
}





//--------------------------------------------------------------------------------
//---- SWfltk_widget::decodeargs_widget() ----------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::decodeargs_widget()
{
  // get some common args

  // widget position and size are handled elsewhere in guessposition() and guesssize()

  // get text position and size
  if (argdefined("textpos"))
    textpos=argval("textpos");
  if (argdefined("textsize"))
    textsize=argval("textsize");
  else
    {
      // set default size for widget
      if (textpos=="bottom")
	textsize=12;
      else
	textsize=14;
    }

  // get the label smartly
  label=argval("label",name);
}




//--------------------------------------------------------------------------------
//---- SWfltk_widget::runargs_align() --------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::runargs_align(Fl_Widget *widgetp,string tpos)
{
  // send the fltk commands needed to align text
  if (tpos=="bottom")
    widgetp->align(FL_ALIGN_BOTTOM|FL_ALIGN_CLIP|FL_ALIGN_WRAP);
  else if (tpos=="left")
    widgetp->align(FL_ALIGN_LEFT|FL_ALIGN_CLIP|FL_ALIGN_WRAP);
  else if (tpos=="topleft")
    widgetp->align(FL_ALIGN_LEFT|FL_ALIGN_TOP|FL_ALIGN_CLIP);
  else if (tpos=="center")
    widgetp->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE|FL_ALIGN_CLIP);
  else
    widgetp->align(FL_ALIGN_CENTER|FL_ALIGN_CLIP|FL_ALIGN_WRAP);

}




















//--------------------------------------------------------------------------------
//---- SWfltk_widget::construct_window() -----------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::construct_window()
{
  // instantiation routine

  // if there is a parent window, create it, if not, no prob.
  // and if we do have a parent, tell fltk that anything we add goes to parent
  parentp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Window",false));
  if (parentp)
    Fl_Group::current(parentp->getwinp());
  
  decodeargs_widget();
  if (!parentp)
    {
      guessextent(label);
      if (subclass()=="Gl")
	{
	  if (xpos!=-1 && ypos!=-1)
	    windowp = new SWfltk_glWindow(configppp,xpos,ypos,width,height,JRstradr(&label));
	  else
	    windowp = new SWfltk_glWindow(configppp,width,height,JRstradr(&label));
	}
      else if (subclass()=="Grob")
	{
	  if (xpos!=-1 && ypos!=-1)
	    windowp = new SWfltk_grobCamera(configppp,xpos,ypos,width,height,JRstradr(&label));
	  else
	    windowp = new SWfltk_grobCamera(configppp,width,height,JRstradr(&label));
	}
      else
	{
	  if (xpos!=-1 && ypos!=-1)
	    windowp=new Fl_Window(xpos,ypos,width,height,JRstradr(&label));
	  else
	    windowp=new Fl_Window(width,height,JRstradr(&label));
	}
      runargs_align(windowp,textpos);
    }
  else
    {
      // add the window as a subwindow
      // note: we will guess where to place it later, so for now just guess the size
      //       when the subwindow is completed (via done()) we add a boxborder and label
      //       (we do this at the completion in case of resizing betwn now and then).
      label=argval("label","");
      guesssize(label);
      if (subclass()=="Gl")
	{
	  windowp = new SWfltk_glWindow(configppp,width,height,JRstradr(&label));
	}
      else if (subclass()=="Grob")
	{
	  windowp = new SWfltk_grobCamera(configppp,width,height,JRstradr(&label));
	}
      else
	windowp=new Fl_Window(width,height,JRstradr(&label));
      (parentp->getwinp())->add(windowp);
    }

  // set some characteristics of the window
  windowp->iconlabel(JRstradr(&name));

  if (subclass()=="Grob")
    runargs_grob();

  // set the widget pointer
  localp=windowp;

  // uncomment to get a window with no border
  //  windowp->set_non_modal();
}



//--------------------------------------------------------------------------------
//---- SWfltk_widget::construct_button() -----------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::construct_button()
{
  // instantiation routine for buttons

  // first insure the existence of the parent and get parent pointer
  parentp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Window",true));
  Fl_Group::current(parentp->getwinp());

  decodeargs_widget();
  guessextent(label);
  if (subclass()=="")
    buttonp=new Fl_Button(xpos,ypos,width,height,label.c_str());
  if (subclass()=="Light")
    buttonp=new Fl_Light_Button(xpos,ypos,width,height,label.c_str());
  buttonp->align(FL_ALIGN_CLIP|FL_ALIGN_WRAP|FL_ALIGN_CENTER);
  buttonp->labelsize(textsize);

  // set the widget pointer
  localp=buttonp;
}




//--------------------------------------------------------------------------------
//---- SWfltk_widget::construct_valuator() ---------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::construct_valuator()
{
  // instantiation routine for valuators (sliders, dials, etc.)
  double min,max,stepsize;
  int minlen=2;
  string tempstring;

  // first insure the existence of the parent and get parent pointer
  parentp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Window",true));
  Fl_Group::current(parentp->getwinp());

  min=argval("min");
  max=argval("max");
  decodeargs_widget();
  parentp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Window",false));
  if (subclass()=="Slider")
    {
      if (label.length()<minlen)
	{
	  tempstring=label;
	  tempstring.append((minlen-label.length()),' ');
	  guessextent(tempstring);
	}
      else
	guessextent(label);

      // guess step
      if (argdefined("stepsize"))
	stepsize=argval("stepsize");
      else
	stepsize=(double)(max-min)/1000;

      // guess initial value
      if (argdefined("value"))
	startvalue=argval("value");
      else
	startvalue=(double)(max+min)/2.0;

      vsliderp= new Fl_Value_Slider(xpos,ypos,width,height, label.c_str());
      vsliderp->type(FL_HOR_NICE_SLIDER);
      vsliderp->box(FL_FLAT_BOX);
      vsliderp->color(10);
      vsliderp->selection_color(1);
      vsliderp->minimum(min);
      vsliderp->maximum(max);
      vsliderp->step(stepsize);
      vsliderp->slider_size(.01);
      vsliderp->labelsize(textsize);
      vsliderp->value(startvalue);
      runargs_align(vsliderp,textpos);

      // set the widget pointer
      localp=vsliderp;
    }
}





//--------------------------------------------------------------------------------
//---- SWfltk_widget::construct_menu() -------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::construct_menu()
{
  // The fltk menu routines are nice BUT dynamic construction is buggy as of (1.13.98)
  // and requires some careful and uncomnfortable trickery.
  int i;
  SWfltk_widget *swp;
  Fl_Menu_Item *itemp;
  CfpVAccessor *varp,*notifierp;
  int idnum;

  // decode basic args for all menu widgets (gets text size, etc.)
  decodeargs_widget();

  if (baseclass()=="Menu")
    {
      // ensure the existence of the parent and get parent pointer
      parentp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Window",true));
      Fl_Group::current(parentp->getwinp());
      guessextent(label);

      if (subclass()=="Bar")
	{
	  localp=menup=new Fl_Menu_Bar(xpos,ypos,width,height,JRstradr(&label));
	  menup->menu(NULL);
	}
      else if (subclass()=="Button")
	{
	  string show=(string)argval("show");
	  if (show=="label")
	    {
	      // the simplest the button has a fixed label
	      localp=menup=new Fl_Menu_Button(xpos,ypos,width,height,label.c_str());
	      menup->menu(NULL);
	    }
	  else if (show=="value")
	    {
	      // the button shows the current value, and has an additional label near button
	      localp=menup=new Fl_Choice(xpos,ypos,width,height,label.c_str());
	      menup->menu(NULL);
	    }
	  else
	    {
	      // this version adds a greyed out unselectable choise equal to the label,
	      // and shows values on the front of the button. there is no outside label.
	      localp=menup=new Fl_Choice(xpos,ypos,width,height,0);
	      menup->menu(NULL);
	      menuflags=FL_MENU_INACTIVE|FL_MENU_DIVIDER;
	      menuindex=menup->add(label.c_str(),0,0,0,menuflags);
	      menup->value(0);
	    }
	}
      else if (subclass()=="Mouse")
	{
	  // this is an invisible "hotspot" area which will activate the menu with a right mouse hold
	  localp=menup=new Fl_Menu_Button(xpos,ypos,width,height,JRstradr(&label));
	  menup->menu(NULL);
	  menup->type(Fl_Menu_Button::POPUP3);
	}

      // bookkeeping
      lastitemp=NULL;
      menuindex=-1;
    }

  else if (baseclass()=="Submenu")
    {
      // For submenus we don't do anything, just keep track of their hierarchical name
      // ensure the existence of the parent menu and get parent pointer
      // All we do is calculate possibly hierarchical menu name.
      parentp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Menu",true));
      localp=menup=(Fl_Menu_ *)(parentp->getlocalp());
      swp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Submenu",false));
      if (swp)
	{
	  menuname=swp->menuname+"/"+label;
	  swp->lastitemp=this;
	}
      else
	{
	  menuname=label;
	  parentp->lastitemp=this;
	}
      // bookkeeping
      menuflags=FL_SUBMENU;
      lastitemp=NULL;
      menuindex=-1;
    }
  else if (baseclass()=="Menuitem")
    {
      // ensure the existence of the parents and get parent pointer
      parentp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Menu",true));
      localp=menup=(Fl_Menu_ *)(parentp->getlocalp());
      swp=(SWfltk_widget *)(configppp->parentinstantiate(this,"Submenu",false));

      if (subclass()=="Divider")
	{
	  if (swp)
	    {
	      if (swp->lastitemp)
		{
		  menuindex=(swp->lastitemp)->menuindex;
		  if (menuindex>-1)
		    {
		      // Now set the divider flag of the last menu item on the parent submenu
		      menuflags=(swp->lastitemp)->menuflags|FL_MENU_DIVIDER;
		      menup->mode(menuindex,menuflags);
		    }
		}
	      else
		;  // error trying to put a divider on an empty submenu
	    }
	  else
	    {
	      // put a divider on root menu
	      if (parentp->lastitemp)
		{
		  menuindex=(parentp->lastitemp)->menuindex;
		  if (menuindex>-1)
		    {
		      // Now set the divider flag of the last menu item on the parent submenu
		      menuflags=(parentp->lastitemp)->menuflags|FL_MENU_DIVIDER;
		      menup->mode(menuindex,menuflags);
		    }
		}
	    }
	}
      else
	{
	  // General purpose menu item

	  // make the label
	  if (swp)
	    menuname=swp->menuname+"/"+label;
	  else
	    menuname=label;
	  

	  // Old add of the item without callback (now replaced with version below)
	  //	  menuindex=menup->add(menuname.c_str());

	  // get the id of the menu item, which will be passed to any listeners
	  if (argdefined("id"))
	    idnum=argval("id");
	  else
	    {
	      // user didin't specify an id, so we make one up
	      idnum=12345;
	    }

	  // make and register a fixed arg callback with the static menuitem valuator
	  accessorp=varp=addvar(new CfpFixedValAccessor<int>("valueout",this,idnum));
	  menuindex=menup->add(menuname.c_str(),0,SWfltk_widget::MenuItemCallback,(void*)varp,0);


	  // set any flags for the item
	  menuflags=0;
	  if (subclass()=="Radio")
	    menuflags|=FL_MENU_RADIO;
	  else if (subclass()=="Toggle")
	    menuflags|=FL_MENU_TOGGLE;
	  menup->mode(menuindex,menuflags);
	  
	  // bookkeeping
	  if (swp)
	    {
	      if (!swp->lastitemp)
		swp->menuindex=menuindex-1; // a kludge to guess index of submenu header when we add first entry
	      swp->lastitemp=this;
	    }
	  else
	    {
	      parentp->menuindex=menuindex-1;
	      parentp->lastitemp=this;
	    }
	}
    }
}












//--------------------------------------------------------------------------------
//---- SWfltk_widget::addaccessors() --------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_widget::addaccessors()
{
  // this is the function that registers accessors for instantiated
  //  member variables, functions and accessors
  CfpVAccessor *varp,*notifierp;

  if (classname()=="Window.Grob")
    {
      // add the variable accessors for directly getting and putting videocam variables
      SWfltk_grobCamera *p=(SWfltk_grobCamera *)localp;

      // create the accessor for zoom and add it to object varlist
      // and add a notifier to mark the window as needing redraw whenever the above var is changed
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float,float>("zoom",this,p,&(p->setzoom),&(p->getzoom)));
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float,float>("distance",this,p,&(p->setdist),&(p->getdist)));
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float,float>("aperture",this,p,&(p->setapt),&(p->getapt)));

      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      // variable for refreshrate
      varp=addvar(new CfpVTAccessor<int>("refreshrate",this,&(p->refreshrate)));
      // create a func accessor and add it to object varlist
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float,float>("euler1",this,p,&(p->seteuler1),&(p->geteuler1)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      // create a func accessor and add it to object varlist
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float,float>("euler2",this,p,&(p->seteuler2),&(p->geteuler2)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      // create a func accessor and add it to object varlist
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float,float>("euler3",this,p,&(p->seteuler3),&(p->geteuler3)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      // create a func accessor and add it to object varlist
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,int>("detail",this,p,&(p->setidetail)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));

      // create a bool accessor for showing camera axes
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,bool>("axes",this,p,&(p->setshowaxes)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      // a bounding box
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,bool>("boundingbox",this,p,&(p->setclearbox)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));

      // accessor for switching preset views
      varp=addvar(new CfpVFAMnotify<SWfltk_grobCamera>("nextview",this,p,&(p->nextview)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));

      // accessors for dollying camera
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float>("xdolly",this,p,&(p->setxdolly)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float>("ydolly",this,p,&(p->setydolly)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,float>("zdolly",this,p,&(p->setzdolly)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
      varp=addvar(new CfpVFAMsetval<SWfltk_grobCamera,int>("view",this,p,&(p->setview)));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));

      // test accessor for examining text scales
      varp=addvar(new CfpVTAccessor<float>("textscale",this,&testtextscale));
      makelistener(varp,new CfpVFAMnotify<SWfltk_grobCamera>("_widget_redraw",this,p,&SWfltk_grobCamera::redraw));
    }

  else if (baseclass()=="Valuator")
    {
      // add callback accessors which receive changes from ftlk
      Fl_Valuator *p=(Fl_Valuator *)localp;

      // create the accessor, store it in our local accessor pointer
      varp=new CfpValAccessor("valueout",this);
      accessorp=varp=addvar(varp);
      // initialize the valueout accessor with the starting value (in case anyone wants to peek at it)
      varp->set((CfpVal)startvalue);

      // register the static valuator callback with fltk, pointing to the accessor
      ((Fl_Widget*)localp)->callback(SWfltk_widget::ValCallback,(void*)varp);

      // create a func accessor and add it to object varlist
      varp=addvar(new CfpVFAMsetvalret<Fl_Valuator,double,int>("valuein",this,p,&(p->value)));

      // add forced callback when it is modified
      makelistener(varp,new CfpVFAMnotify<Fl_Valuator>("_force_callback",this,p,&Fl_Valuator::do_callback));

    }
  else if (baseclass()=="Button")
    {
      // add callback accessors which receive changes from ftlk
      Fl_Button *p=(Fl_Button *)localp;

      // create the accessor, store it in our local accessor pointer
      varp=new CfpValAccessor("valueout",this);
      accessorp=varp=addvar(varp);

      // register the static valuator callback with fltk, pointing to the accessor
      ((Fl_Widget*)localp)->callback(SWfltk_widget::ButtonCallback,(void*)varp);
    }
}






//--------------------------------------------------------------------------------
//---- SWfltk_widget::ValCallback()
//--------------------------------------------------------------------------------

void SWfltk_widget::ValCallback(Fl_Widget *widgep,void *accp)
{
  // fltk valuator callbacks route through this function on their way to accessors
  // the widget pointer is case to a Fl_Valuator so don't let nonvaluators register this callback

  // cast incoming values
  Fl_Valuator *valuatorp=(Fl_Valuator*)widgep;
  CfpVAccessor *varp=(CfpVAccessor*)accp;
  CfpVal val=CfpVal((long double)valuatorp->value());

  // then call the accessor with the val
  varp->set(&val);
}


//--------------------------------------------------------------------------------
//---- SWfltk_widget::ButtonCallback()
//--------------------------------------------------------------------------------

void SWfltk_widget::ButtonCallback(Fl_Widget *widgep,void *accp)
{
  // fltk button callbacks route through this function on their way to accessors
  // the widget pointer is cast to a Fl_Button so don't let other widgets register this callback

  // cast incoming values
  Fl_Button *buttonp=(Fl_Button*)widgep;
  CfpVAccessor *varp=(CfpVAccessor*)accp;
  CfpVal val=CfpVal((int)buttonp->value());

  // then call the accessor with the val
  varp->set(&val);
}


//--------------------------------------------------------------------------------
//---- SWfltk_widget::MenuItemCallback()
//--------------------------------------------------------------------------------

void SWfltk_widget::MenuItemCallback(Fl_Widget *widgep,void *accp)
{
  // fltk valuator callbacks route through this function on their way to accessors
  // the widget pointer is case to a Fl_Valuator so don't let nonvaluators register this callback
  //  int value=((Fl_Menu_ *)widgep)->mvalue();
  int value=((Fl_Menu_ *)widgep)->value();

  // cast incoming values
  CfpVAccessor *varp=(CfpVAccessor*)accp;
  CfpVal val=CfpVal(value);

  // then call the accessor with the val
  varp->set(&val);
}




//--------------------------------------------------------------------------------
//---- SWfltk_widget::connectwires
//--------------------------------------------------------------------------------

void SWfltk_widget::connectwires()
{
  // What we want here is to wire together accessors
  //  this is actually a hack, to test callback functions. we will later remove it.
  // What we do here, is, if the person specifies   callback=varname,
  //  we treat this as a wire from the local accessorp -> varname.
  //  as if the person said make a wire from the current fltk widget to the varname
  CfpVAccessor *sourcep,*targetp;
  CfpVal val;

  if (argdefined("callback"))
    {
      configppp->debug("registering callback from "+prettyname()+".\n");
      // the user has specified a callback to install
      // get the CfpVal which should point to the target accessor
      val=argval("callback");
      targetp=val.get_vaccesspointer();

      // now get the source accessore
      sourcep=accessorp;
      if (sourcep==NULL)
	cout << "ERRRRRRRROR: null pointer as source.\n";
      
      // now wire them togeher
      sourcep->addlistener(targetp);
    }
}




void SWfltk_widget::runargs_grob()
{
  // now set the drawer using lots of casting
  CfpVal val=argval("drawer");
  CfpObject *objp=val.get_objectpointer();
  string titlestr,substring;
  GrobVideoCameraDrawer *gvcdp=(GrobVideoCameraDrawer *)(objp->getlocalp());
  SWfltk_grobCamera *gcp=(SWfltk_grobCamera *)windowp;

  // set drawer (which also adds the camera as a listener)
  gcp->setdrawer(gvcdp);

  // set onscreen titles
  titlestr=argval("title","");
  substring=argval("subtitle","");
  if (titlestr!="" || substring!="")
    gcp->settitle(titlestr,substring);

  // fix for double buffer?
  if (gvcdp->grobvidcam_supportsincdraw() && false)
    {
      // incremental drawing might only be allowable in singlebuffered gl windows?
      ((SWfltk_grobCamera*)windowp)->singlebuffer();
    }
}





























































//--------------------------------------------------------------------------------
//---- SWfltk_glWindow::initialize() ---------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_glWindow::initialize(Configpp *incfpfp)
{
  // initialize the window on construction (may not be viewable/writable yet)
  configppp=incfpfp;
  flgl_prepared=false;
  hiding=false;
}



//--------------------------------------------------------------------------------
//---- SWfltk_glWindow::draw() ---------------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_glWindow::draw()
{
  // draw the window if appropriate

  if (hiding)
    return;
  if (!flgl_prepared)
    flgl_prepare();
  if (!valid())
    validify();

  // now call the derived draw function
  customdraw();
}


//--------------------------------------------------------------------------------
//---- SWfltk_glWindow::draw_overlay() -------------------------------------------
//--------------------------------------------------------------------------------

void SWfltk_glWindow::draw_overlay()
{
  // draw the overlay if appropriate

  if (hiding)
    return;
  if (!flgl_prepared)
    flgl_prepare();
  if (!valid())
    validify();

  // now call the derived draw_overlay function
  customdraw_overlay();
}



//--------------------------------------------------------------------------------
//---- SWfltk_glWindow::validify
//--------------------------------------------------------------------------------

void SWfltk_glWindow::validify()
{
  // valid() is used to avoid reinitializing the GL transformation for each redraw
  valid(1);
  glLoadIdentity();
  glViewport(0,0,w(),h());
}








//--------------------------------------------------------------------------------
//---- SWfltk_grobWindow
//--------------------------------------------------------------------------------


void SWfltk_grobCamera::grobcam_initialize()
{
  // initialize the GrobVideoCamera (note: window may not be on screen yet)
}




//--------------------------------------------------------------------------------
//---- SWfltk_grobCamera::flgl_prepare
//--------------------------------------------------------------------------------

void SWfltk_grobCamera::flgl_prepare()
{
  // this function is called right after the first time the window is shown by the gui

  // set the prepared flag
  flgl_prepared=true;
}



//--------------------------------------------------------------------------------
//---- SWfltk_grobCamera::customdraw
//--------------------------------------------------------------------------------

void SWfltk_grobCamera::customdraw()
{
  // this is called whenever the gui says we should redraw our window
  bool incdraw;

  if (gdrawerp)
    {
      //      cout << "damage=" << damage() << ".\n";
      if (damage()==USER_DAMAGE)
	incdraw=true;
      else
	incdraw=false;
      if (incdraw)
	{
	  // try an incremental redraw
	  //	  cout << "incremental redraw.\n";
	  if (incdraw=(gdrawerp->grobvidcam_canincdraw() & canincdraw()))
	    {
	      begin_incdraw();
	      gdrawerp->grobvidcam_incdraw(this);
	      end_incdraw();
	    }
	}

      if (!incdraw)
	{
	  // full redraw
	  begin_draw();
	  gdrawerp->grobvidcam_draw(this);
	  end_draw();
	}

    }
}




void SWfltk_grobCamera::request_redraw(GrobVideoCameraDrawer *ingdrawerp)
{
  // the drawer of our window has new info and wants to redraw into the window
  // so we need to tell fltk gui that it should redraw us (re-tell us to re-draw)
  // note: we may get multiple calls her between actual redraws
  
  damage(USER_DAMAGE);

  // calling redraw forces the entire window to completely redraw
  // redraw();
}







void SWfltk_widget::glstartcheck()
{
  // GL goes crazy if you try to do anything with it (create displaylists,etc.)
  //  if you have not yet put up a window, so we make a fake one in the begining.
  int count;
  int retv;
  
  Fl::gl_visual(FL_RGB8);

  // make a fake window (might be nice to put up a little GL graphic in there)
  if (!glinitwin)
    {
      // now trick fltk to create, draw, and init it sufficiently
      glinitwin=new SWfltk_glinitWindow();
      glinitwin->show();
      Fl::check();
      glinitwin->redraw();
      Fl::check();
      glinitwin->show();
      glinitwin->redraw();
      Fl::check();
      for (count=1;count<=100;++count)
	{
	  usleep(9000L);
	  Fl::check();
	  glinitwin->redraw();
	  Fl::check();
	  retv=(int)glGenLists(1);
	  if (retv)
	    break;
	}
    }
}





void SWfltk_glinitWindow::customdraw()
{
  // draw something to be on screen when we start up
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  //  glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, "GL Welcome");
}








void SWfltk_widget::construct_cameraview()
{
  // build and add a view to the camera
  CameraView *viewp;
  SWfltk_grobCamera *camp;
  float e1,e2,e3,zoom,ydolly;

  // find parent videocamera
  camp=(SWfltk_grobCamera *)((configppp->parentinstantiate(this,"Window.Grob",true))->getlocalp());

  // get the args
  e1=argval("e1");
  e2=argval("e2");
  e3=argval("e3");
  zoom=argval("zoom");
  ydolly=argval("ydolly");

  // create the camera view
  viewp=new CameraView(e1,e2,e3,zoom,ydolly);

  // add it to the camera
  camp->addview(viewp);
}





// }
// Namespace close-brace
