// legcontroller.h
// this controller picks the goal angles for the 3 segments of a hexapod leg

// forward delcarations
class HCleg;

#ifndef legcontrollerh_defined
#define legcontrollerh_defined


class HCleg
{
public:
  HCleg(){initialize();};
public:
  virtual void initialize();
  void process(float curtime);
public:
  virtual void setconstants();
  virtual void setrisetime(float inval) {risetime=inval;setstabletime(stabletime);};
  virtual void setstabletime(float inval) {stabletime=risetime+inval;setwalktime(walktime);};
  virtual void setwalktime(float inval) {walktime=stabletime+inval;};
protected:
  float scalerange(float min,float max,float val);
  float scaleout(float min,float max,float dist);
protected:
  bool standingmode;
  float phase;
  float cycletime;
  float whereincycle;
  float worldtime;
  float deltat;
  int whichcyc;
protected:
  float lasttime;
  float elapsedtime;
  float startcycle;
  float risetime;
  float stabletime;
  float walktime;
  float back;
  float lift;
  float forward;
  float lower;
  float f1;
  float f2;
  float f3;
  float fl1;
  float fl2;
  float fl3;
  float l1;
  float l2;
  float l3;
  float lf1;
  float lf2;
  float lf3;
protected:
  float ang1,ang2,ang3;
  float goal1,goal2,goal3;
protected:
  float cycleloc;
  float igoal1,igoal2,igoal3;
  float sang1,sang2,sang3;
  bool started;
public:
  void setphase(float inphase);
  void setcycletime(float incycletime){cycletime=incycletime;};
  float getgoal1(){return goal1;};
  float getgoal2(){return goal2;};
  float getgoal3(){return goal3;};
  void setang1(float inang){ang1=inang;};
  void setang2(float inang){ang2=inang;};
  void setang3(float inang){ang3=inang;};
};


class HCleg2 : public HCleg
{
public:
  virtual void setconstants();
};


class HCleg3 : public HCleg
{
public:
  virtual void setconstants();
};

class HCleg4 : public HCleg
{
public:
  virtual void setconstants();
};

class HCleg5 : public HCleg
{
public:
  virtual void setconstants();
};




#endif
