// cfpmacros.C
// Configpp classes for using macros (like user-defined functions but less robust)

// forward delcarations
class CfpMacroClass;
class CfpMacroObject;

#ifndef cfpmacrosh_defined
#define cfpmacrosh_defined

#include "cfpinc.h"




// CfpMacroObject is instantiated once for each macro instantiation

class CfpMacroObject : public CfpObject
{
private:
  CfpMacroClass *macroclassp;
private:
  list<CfpVAccessor *>arglist;
  list<CfpVAccessor *>varlist;
public:
  CfpMacroObject(Configpp *cfpfp,CfpMacroClass *inmacroclassp);
  CfpMacroObject(Configpp *cfpfp,CfpClass *inclassp,string oname,CfpMacroClass *inmacroclassp);
public:
  virtual void registerwrappers(CfpFactory *sfactp);
  CfpObject *makenew(CfpClass *inclassp,string objname);		// generic makenew
  CfpVal done();							// any return value?
  void destruct();							// deinstatiate wrapped obj
  void construct();							// no arg constructor of wrappedobj;
private:
  void addaccessors();							// add any variable accessors
public:
  virtual string postparse();
};



// CfpMacroClass holds the definition of a macro, and the information needed to invoke it and create a CfpMacroObject

class CfpMacroClass
{
  friend class CfpMacroObject;
private:
  Configpp *configppp;
  CfpMacroObject *allocatorobj;
  CfpClass *cfpclassp;
  string name;
  string codeblock;
private:
  list<CfpMemberVar *>varlist;
public:
  CfpMacroClass(Configpp *inconfigppp,string inname);
  ~CfpMacroClass();
public:
  void setcodeblock(string incodeblock) {codeblock=incodeblock;};
  string getcodeblock(){return codeblock;};
  string getname(){return name;};
public:
  void addarg(string vaname,CfpVal &vadefault,string valabel);
  void addvar(string vaname,CfpVal &vadefault,string valabel);
};








#endif
