// cfpmember.C

#include "cfpinc.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Configpp{








//--------------------------------------------------------------------------------
//---- CfpMember -----------------------------------------------------------------
//--------------------------------------------------------------------------------

CfpMember::CfpMember(CfpClass *inclassp, string inname,string inlabel,string indesc)
{
  // initialize the member (note this is the base constructor for memberarg,membervar, and memberfunc
  classp=inclassp;
  name=inname;
  label=inlabel;
  description=indesc;
}



//--------------------------------------------------------------------------------
//---- CfpMemberVA ---------------------------------------------------------------
//--------------------------------------------------------------------------------

CfpMemberVA::CfpMemberVA(CfpClass *inclassp, string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr,string typestr,string inrangestr,bool inread,bool inwrite,string inpar, string inchild,string indesc)
  : CfpMember(inclassp,inname,inlabel)
{
  // construct a new member argument (also used for member variables), beyond what CfpMember base does.
  rangestr=inrangestr;
  initval=ininitval;
  searchscope=insscope;
  vectorsize=1;

  // look up the unit measurement and throw error if we don't find it
  unitp=inclassp->lookupUnit(unitstr,true);
  typep=inclassp->lookupType(typestr,true);

  // defaults
  readable=inread;
  writeable=inwrite;
  parentstr=inpar;
  childstr=inchild;
}

//--------------------------------------------------------------------------------
//---- CfpMemberVA ---------------------------------------------------------------
//--------------------------------------------------------------------------------

CfpMemberVA::CfpMemberVA(CfpClass *inclassp,int vecsize, string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr,string typestr,string inrangestr,bool inread,bool inwrite,string inpar, string inchild,string indesc)
  : CfpMember(inclassp,inname,inlabel)
{
  // construct a new vector member argument (also used for member variables), beyond what CfpMember base does.
  rangestr=inrangestr;
  initval=ininitval;
  searchscope=insscope;
  vectorsize=vecsize;

  // look up the unit measurement and throw error if we don't find it
  unitp=inclassp->lookupUnit(unitstr,true);
  typep=inclassp->lookupType(typestr,true);

  // defaults
  readable=inread;
  writeable=inwrite;
  parentstr=inpar;
  childstr=inchild;
}



//--------------------------------------------------------------------------------
//---- CfpMemberVA::getdefaultval() ----------------------------------------------
//--------------------------------------------------------------------------------

CfpVal CfpMemberVA::getdefaultval()
{
  // either use the build in default value OR look for a parent value to use if
  // the searchscope flag is set

  if (!searchscope)
    return initval;

  // if there is a higher scope def. of the value then we use it as the default instead of ininitval
  CfpVal val=(getcfpp())->lookupVal(name,false);
  if (!val.isdefined())
    return initval;

  return val;
}



//--------------------------------------------------------------------------------
//---- CfpMemberVA::setaccess() --------------------------------------------------
//--------------------------------------------------------------------------------

void CfpMemberVA::setaccess(bool inread,bool inwrite,string inpar, string inchild)
{
  // set some access parameters
  readable=inread;
  writeable=inwrite;
  parentstr=inpar;
  childstr=inchild;
}



string CfpMemberVA::getunitstr()
{
  // return the string name of the units for this variable/arg
  if (unitp)
    return unitp->prettyname();
  else
    return "";
}




//--------------------------------------------------------------------------------
//---- CfpMemberVar --------------------------------------------------------------
//--------------------------------------------------------------------------------

CfpMemberVar::CfpMemberVar(CfpClass *inclassp, string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr,string typestr,string inrangestr,bool inread,bool inwrite,string inpar, string inchild,string indesc)
  : CfpMemberVA(inclassp,inname,ininitval,insscope,inlabel,unitstr,typestr,inrangestr,inread,inwrite,inpar,inchild,indesc)
{
  // member var constructor
}

//--------------------------------------------------------------------------------
//---- CfpMembervVar --------------------------------------------------------------
//--------------------------------------------------------------------------------

CfpMemberVar::CfpMemberVar(CfpClass *inclassp, int vecsize, string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr,string typestr,string inrangestr,bool inread,bool inwrite,string inpar, string inchild,string indesc)
  : CfpMemberVA(inclassp,vecsize,inname,ininitval,insscope,inlabel,unitstr,typestr,inrangestr,inread,inwrite,inpar,inchild,indesc)
{
  // member vector var constructor
}


//--------------------------------------------------------------------------------
//---- CfpMemberFunc -------------------------------------------------------------
//--------------------------------------------------------------------------------

CfpMemberFunc::CfpMemberFunc(CfpClass *inclassp, string inname,string inlabel,string indesc, string inargstring, string retstring)
  : CfpMember(inclassp,inname,inlabel,indesc)
{
  // member func constructor
}














































//}
// Namespace close-brace



