// cfpmember.h
// this file defines the Member class and the Accessor class which is used to tomanipualte
//  member values.

// Start file
#ifndef INC_cfpmemberh
#define INC_cfpmemberh

#include "cfpinc.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Configpp{






//--------------------------------------------------------------------------------
//---- CfpMember -----------------------------------------------------------------
//--------------------------------------------------------------------------------
//: The base class for deriving member arguments,variables, and functions

class CfpMember
{
  friend class CfpAccessor;
protected:
  CfpClass *classp;
  string name;
  string label;
  string description;
public:
  CfpMember(CfpClass *inclassp, string inname,string inlabel,string indesc="");
public:
  Configpp *getcfpp(){return classp->getcfpp();};			// accessor
  string getname() {return name;};					// accessor
  string getlabel() {return label;};					// accessor
  string getdesc() {return description;};				// accessor
};



//--------------------------------------------------------------------------------
//---- CfpMemberVA ---------------------------------------------------------------
//--------------------------------------------------------------------------------
//: The base class for deriving member arguments and variables

class CfpMemberVA: public CfpMember
{
protected:
  CfpUnit *unitp;							// pointer to the unit
  CfpType *typep;							// pointer to the type
  string rangestr;							// range or enumeration
  CfpVal initval;							// default initial value
  bool searchscope;
  int vectorsize;  // dimensions of vector
protected:
  bool readable;							// is the var user readable?
  bool writeable;							// is the var user writable?
  string parentstr;							// allowed/disallowed parents
  string childstr;							// allowed/disallowed children
public:
  CfpMemberVA(CfpClass *inclassp, string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr="",string typestr="",string inrangestr="",bool inread=true,bool inwrite=true,string inpar="", string inchild="",string indesc="");
  CfpMemberVA(CfpClass *inclassp, int vecsize, string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr="",string typestr="",string inrangestr="",bool inread=true,bool inwrite=true,string inpar="", string inchild="",string indesc="");
public:
  CfpVal getdefaultval();							// accessor;
  CfpVal getinitval() {return initval;};							// accessor;
  void setaccess(bool inread,bool inwrite,string inpar="", string inchild="");	// accessor;
  string getunitstr();								// accessor;
  int getvectorsize() {return vectorsize;};                                     // accessor;
public:
  bool allowparent(string pclassname,CfpClass *pclassp,CfpObject *pobjp);
  bool allowchild(string pclassname,CfpClass *pclassp,CfpObject *pobjp);
};




//--------------------------------------------------------------------------------
//---- CfpMemberVar --------------------------------------------------------------
//--------------------------------------------------------------------------------
//: Member variables

class CfpMemberVar: public CfpMemberVA
{
public:
  CfpMemberVar(CfpClass *inclassp,string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr,string typestr,string inrangestr,bool inread=true,bool inwrite=true,string inpar="", string inchild="",string indesc="");
  CfpMemberVar(CfpClass *inclassp,int vecsize,string inname,CfpVal ininitval,bool insscope,string inlabel,string unitstr,string typestr,string inrangestr,bool inread=true,bool inwrite=true,string inpar="", string inchild="",string indesc="");
};



//--------------------------------------------------------------------------------
//---- CfpMemberFunc -------------------------------------------------------------
//--------------------------------------------------------------------------------
//: Member functions

class CfpMemberFunc: public CfpMember
{
private:
  string argstring;
  string retstring;
public:
  CfpMemberFunc(CfpClass *inclassp,string inname,string inlabel,string indesc,string inargstring,string retstring);
public:
  string getargstring() {return argstring;};							// accessor
  string getretstring() {return retstring;};							// accessor
};







































//}
// Namespace close-brace
#endif
