// cfpwiresplice.h
// This file describes some basic splicers that can be used as black boxes on Wires

// forward declarations
class CfpstdSpliceNoise;
class CfpstdSpliceDelay;


#ifndef INC_cfpwiresplice
#define INC_cfpwiresplice

#include "cfpinc.h"
#include "cfpstdlib.h"

//Not implemented in gcc yet (2.8.1)
//namespace Configpp{







//:CfpSpliceNoise class is a black box that creates noise on a wire
class CfpSpliceNoise: public CfpstdSplice
{
private:
  double noisemean;
  double noisestddev;
public:
  CfpSpliceNoise(bool registerme=true):CfpstdSplice(false) {if (registerme) GlobalFactoryreg(this,"CfpSpliceNoise");};
  CfpSpliceNoise(Configpp *cfpfp,CfpClass *inclassp,string oname);
public:
  virtual void registerwrappers(CfpFactory *sfactp);
  virtual CfpObject *makenew(CfpClass *inclassp,string objname);		// generic makenew
  virtual void construct();							// no arg constructor of wrappedobj
  virtual void addaccessors();
  virtual CfpVal done();							
protected:
  virtual void compute();
};


class CfpandTime
  {
    friend class CfpSpliceDelay;
  public:
    CfpandTime(CfpVal *valp,double intimestamp) {val=*valp;timestamp=intimestamp;};
  private:
    CfpVal val;
    double timestamp;
  };


//:CfpSpliceDelay class is a black box that can create various kinds of delays on lines
class CfpSpliceDelay: public CfpstdSplice
{
private:
  double deltatrate;
  int samplerate;
  double timedelay;
  int stepdelay;
  bool alwaysoutput;
  bool shouldoutput;
  bool shouldcompute;
  long stepcounter;
  double deltatcounter;
  double lasttime;
private:
  int buffersize;
  deque<CfpandTime *> pipeline;
public:
  CfpSpliceDelay(bool registerme=true):CfpstdSplice(false) {if (registerme) GlobalFactoryreg(this,"CfpSpliceDelay");};
  CfpSpliceDelay(Configpp *cfpfp,CfpClass *inclassp,string oname);
public:
  virtual void registerwrappers(CfpFactory *sfactp);
  virtual CfpObject *makenew(CfpClass *inclassp,string objname);		// generic makenew
  virtual void construct();							// no arg constructor of wrappedobj;
  virtual void addaccessors();
  virtual CfpVal done();							
  virtual void destruct();							
private:
  void push(CfpVal *valp,double timeval);
  void pop(CfpVal *valp);
  double peektime();
protected:
  virtual void preprocessinput() {;};
  virtual bool iscomputetime();
  virtual bool isoutputtime();
  virtual void compute();
};
























//}
// Namespace close-brace
#endif
