// Cfpwrap.C

#include "cfpinc.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Configpp{


CfpWrap::CfpWrap(Configpp *cfpfp,CfpClass *inclassp,string oname)
  :CfpObject(cfpfp,inclassp,oname)
{
  // this is the constructor that gets called every time the user creates a new
  // instantiated object of the class
}



CfpObject *CfpWrap::makenew(CfpClass *inclassp,string objname)
{
  // create a new instance of our wrapped class as an object
  CfpObject *newp=NULL;

  configppp->debug("creating a new instance of CfpWrap.");
  newp=new CfpWrap(configppp,inclassp,objname);

  return newp;
}





void CfpWrap::registerwrappers(CfpFactory *sfactp)
{
  // this is the constructor that gets called ONCE when the class is registered with the factory.
  CfpMemberVar *varp;

  //  classp=sfactp->registerclass(" _Configpp"," _Configpp",this);
  classp=sfactp->registerclass(" _pConfigpp"," _Configpp",this);

  sfactp->addalias("configpp","Configpp");

  // Add the members to the CLASS and OBJECT
  varp=classp->addvar("debugmode","",false,"is debug mode engaged?");
  varp->setaccess(true,true);
  varp=classp->addvar("quit","",false,"callback this to quit program");
}




void CfpWrap::construct()
{
  // Add the members to the OBJECT
  addobjmembers();
  
  // if we are a wrapper for another class, we would allocate that target wrapped class here.
  // and save it to a local variable.  otherwise this is its own wrapper.
  instantiated=true;
}





void CfpWrap::addobjmembers()
{
  // add the member variables to the OBJECT
  addvar(new CfpVTAccessor<bool>("debugmode",this,&(configppp->Debugmode)));
  addvar(new CfpVFAMnotify<Configpp>("quit",this,configppp,&Configpp::quit_request));
}








// }
// Namespace close-brace
