/***********************************************************************

 FVector.h
 FVector Class Header File
 Copyright (C) 1993
        Lyle Hall 1993/94
        Eric C. Welton 1993/94
        Beckman Institute - Urbana, Illinois
        For Neuronal Pattern Analysis Group and Hexapod Project

        These libraries are free and may be redistributed and/or modified,
        provided the above notice and this paragraph are included.
        These libraries may not be sold and are distributed without
        any warranty or implication of fitness for a purpose.

 General Information

        The FVector library provides fundamental vector-of-float
 operations.

***********************************************************************/

#ifndef FVECTOR_HDR 
#define FVECTOR_HDR 

#define __DONT_DEFINE_VECTOR_TEMPLATE
#define TYPE         float
#define VCLASSNAME   FVector
#define MCLASSNAME   FMatrix

// If we haven't included the FMatrix header file (and thus
// declared the FMatrix class) we must forward reference
// the FMatrix class.
#ifndef FMATRIX_HDR
class FMatrix;
#endif

// next we have to make sure that the VectorT.h header gets
// included
#ifdef VECTOR_HDR
#undef VECTOR_HDR
#endif
#include <VectorT.h>

#undef __DONT_DEFINE_VECTOR_TEMPLATE
#undef TYPE
#undef VCLASSNAME
#undef MCLASSNAME

#endif
