/***********************************************************************

 Matrix.h
 Matrix Package
 Copyright (C) 1993
        Lyle Hall 1993/94
        Eric C. Welton 1993/94
        Beckman Institute - Urbana, Illinois
        For Neuronal Pattern Analysis Group and Hexapod Project

        These libraries are free and may be redistributed and/or modified,
        provided the above notice and this paragraph are included.
        These libraries may not be sold and are distributed without
        any warranty or implication of fitness for a purpose.

 General Information

        The MatrixT library provides fundamental matrix operations.

***********************************************************************/

#ifndef MATRIX_PACKAGE_HDR
#define MATRIX_PACKAGE_HDR


//======================================================================
//
// Handle default precision selection
//
//    1) if DEFAULT_PRECISION is not defined, set it to 'float'
//    2) if DEFAULT_PRECISION is defined check to see if it is
//       'float':    set DEF_PREC_MATRIX_NAME to 'FMatrix'
//                   set DEF_PREC_MATRIX_PREFIX to 'F'
//       'double':   set DEF_PREC_MATRIX_NAME to 'DMatrix'
//                   set DEF_PREC_MATRIX_PREFIX to 'D'
//    3) correctly redefine the type default type names
//    4) if the concatentation macros have not been defined,
//       then define them
//
#ifndef DEFAULT_PRECISION
#define DEFAULT_PRECISION float
#endif

#if DEFAULT_PRECISION == float
#include <FMatrix.h>
typedef FMatrix Matrix;
#elif DEFAULT_PRECISION == double
#include <DMatrix.h>
typedef DMatrix Matrix;
#else
#error DEFAULT_PRECISION is not defined correctly, must be double or float.
#endif

#ifdef __Concat2
#undef __Concat2
#endif
#ifdef _Concat2
#undef _Concat2
#endif
#define __Concat2(a,b) a##b
#define _Concat2(a,b) __Concat2(a,b)

#ifdef __Concat3
#undef __Concat3
#endif
#ifdef _Concat3
#undef _Concat3
#endif
#define __Concat3(a,b,c) a##b##c
#define _Concat3(a,b,c) __Concat3(a,b,c)

#endif
