// grobcolormaps.C

// The verbose grobGlHelper member functions for building color maps
// i tried to find reasonable algorithms for generating them, but eventually had to just use
// existing numbers (see matlab colormaps).  might be nice to see how coarsly we could interpolate.

// Also, there really only needs to be one global/static copy of each color map.
//  so we might want grobglhelper to build these and return pointers to them


#include "grob.h"


JRinterpolater* GrobGlHelper::rgbramp_hot(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(0.0417, 0, 0);
  jip->addcontrolpoint(0.0833, 0, 0);
  jip->addcontrolpoint(0.1250, 0, 0);
  jip->addcontrolpoint(0.1667, 0, 0);
  jip->addcontrolpoint(0.2083, 0, 0);
  jip->addcontrolpoint(0.2500, 0, 0);
  jip->addcontrolpoint(0.2917, 0, 0);
  jip->addcontrolpoint(0.3333, 0, 0);
  jip->addcontrolpoint(0.3750, 0, 0);
  jip->addcontrolpoint(0.4167, 0, 0);
  jip->addcontrolpoint(0.4583, 0, 0);
  jip->addcontrolpoint(0.5000, 0, 0);
  jip->addcontrolpoint(0.5417, 0, 0);
  jip->addcontrolpoint(0.5833, 0, 0);
  jip->addcontrolpoint(0.6250, 0, 0);
  jip->addcontrolpoint(0.6667, 0, 0);
  jip->addcontrolpoint(0.7083, 0, 0);
  jip->addcontrolpoint(0.7500, 0, 0);
  jip->addcontrolpoint(0.7917, 0, 0);
  jip->addcontrolpoint(0.8333, 0, 0);
  jip->addcontrolpoint(0.8750, 0, 0);
  jip->addcontrolpoint(0.9167, 0, 0);
  jip->addcontrolpoint(0.9583, 0, 0);
  jip->addcontrolpoint(1.0000, 0, 0);
  jip->addcontrolpoint(1.0000,0.0417, 0);
  jip->addcontrolpoint(1.0000,0.0833, 0);
  jip->addcontrolpoint(1.0000,0.1250, 0);
  jip->addcontrolpoint(1.0000,0.1667, 0);
  jip->addcontrolpoint(1.0000,0.2083, 0);
  jip->addcontrolpoint(1.0000,0.2500, 0);
  jip->addcontrolpoint(1.0000,0.2917, 0);
  jip->addcontrolpoint(1.0000,0.3333, 0);
  jip->addcontrolpoint(1.0000,0.3750, 0);
  jip->addcontrolpoint(1.0000,0.4167, 0);
  jip->addcontrolpoint(1.0000,0.4583, 0);
  jip->addcontrolpoint(1.0000,0.5000, 0);
  jip->addcontrolpoint(1.0000,0.5417, 0);
  jip->addcontrolpoint(1.0000,0.5833, 0);
  jip->addcontrolpoint(1.0000,0.6250, 0);
  jip->addcontrolpoint(1.0000,0.6667, 0);
  jip->addcontrolpoint(1.0000,0.7083, 0);
  jip->addcontrolpoint(1.0000,0.7500, 0);
  jip->addcontrolpoint(1.0000,0.7917, 0);
  jip->addcontrolpoint(1.0000,0.8333, 0);
  jip->addcontrolpoint(1.0000,0.8750, 0);
  jip->addcontrolpoint(1.0000,0.9167, 0);
  jip->addcontrolpoint(1.0000,0.9583, 0);
  jip->addcontrolpoint(1.0000,1.0000, 0);
  jip->addcontrolpoint(1.0000,1.0000,0.0625);
  jip->addcontrolpoint(1.0000,1.0000,0.1250);
  jip->addcontrolpoint(1.0000,1.0000,0.1875);
  jip->addcontrolpoint(1.0000,1.0000,0.2500);
  jip->addcontrolpoint(1.0000,1.0000,0.3125);
  jip->addcontrolpoint(1.0000,1.0000,0.3750);
  jip->addcontrolpoint(1.0000,1.0000,0.4375);
  jip->addcontrolpoint(1.0000,1.0000,0.5000);
  jip->addcontrolpoint(1.0000,1.0000,0.5625);
  jip->addcontrolpoint(1.0000,1.0000,0.6250);
  jip->addcontrolpoint(1.0000,1.0000,0.6875);
  jip->addcontrolpoint(1.0000,1.0000,0.7500);
  jip->addcontrolpoint(1.0000,1.0000,0.8125);
  jip->addcontrolpoint(1.0000,1.0000,0.8750);
  jip->addcontrolpoint(1.0000,1.0000,0.9375);
  //  jip->addcontrolpoint(1.0000,1.0000,1.0000);
  return jip;
}



JRinterpolater* GrobGlHelper::rgbramp_cool(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(0,1.0000,1.0000);
  jip->addcontrolpoint(0.0159,0.9841,1.0000);
  jip->addcontrolpoint(0.0317,0.9683,1.0000);
  jip->addcontrolpoint(0.0476,0.9524,1.0000);
  jip->addcontrolpoint(0.0635,0.9365,1.0000);
  jip->addcontrolpoint(0.0794,0.9206,1.0000);
  jip->addcontrolpoint(0.0952,0.9048,1.0000);
  jip->addcontrolpoint(0.1111,0.8889,1.0000);
  jip->addcontrolpoint(0.1270,0.8730,1.0000);
  jip->addcontrolpoint(0.1429,0.8571,1.0000);
  jip->addcontrolpoint(0.1587,0.8413,1.0000);
  jip->addcontrolpoint(0.1746,0.8254,1.0000);
  jip->addcontrolpoint(0.1905,0.8095,1.0000);
  jip->addcontrolpoint(0.2063,0.7937,1.0000);
  jip->addcontrolpoint(0.2222,0.7778,1.0000);
  jip->addcontrolpoint(0.2381,0.7619,1.0000);
  jip->addcontrolpoint(0.2540,0.7460,1.0000);
  jip->addcontrolpoint(0.2698,0.7302,1.0000);
  jip->addcontrolpoint(0.2857,0.7143,1.0000);
  jip->addcontrolpoint(0.3016,0.6984,1.0000);
  jip->addcontrolpoint(0.3175,0.6825,1.0000);
  jip->addcontrolpoint(0.3333,0.6667,1.0000);
  jip->addcontrolpoint(0.3492,0.6508,1.0000);
  jip->addcontrolpoint(0.3651,0.6349,1.0000);
  jip->addcontrolpoint(0.3810,0.6190,1.0000);
  jip->addcontrolpoint(0.3968,0.6032,1.0000);
  jip->addcontrolpoint(0.4127,0.5873,1.0000);
  jip->addcontrolpoint(0.4286,0.5714,1.0000);
  jip->addcontrolpoint(0.4444,0.5556,1.0000);
  jip->addcontrolpoint(0.4603,0.5397,1.0000);
  jip->addcontrolpoint(0.4762,0.5238,1.0000);
  jip->addcontrolpoint(0.4921,0.5079,1.0000);
  jip->addcontrolpoint(0.5079,0.4921,1.0000);
  jip->addcontrolpoint(0.5238,0.4762,1.0000);
  jip->addcontrolpoint(0.5397,0.4603,1.0000);
  jip->addcontrolpoint(0.5556,0.4444,1.0000);
  jip->addcontrolpoint(0.5714,0.4286,1.0000);
  jip->addcontrolpoint(0.5873,0.4127,1.0000);
  jip->addcontrolpoint(0.6032,0.3968,1.0000);
  jip->addcontrolpoint(0.6190,0.3810,1.0000);
  jip->addcontrolpoint(0.6349,0.3651,1.0000);
  jip->addcontrolpoint(0.6508,0.3492,1.0000);
  jip->addcontrolpoint(0.6667,0.3333,1.0000);
  jip->addcontrolpoint(0.6825,0.3175,1.0000);
  jip->addcontrolpoint(0.6984,0.3016,1.0000);
  jip->addcontrolpoint(0.7143,0.2857,1.0000);
  jip->addcontrolpoint(0.7302,0.2698,1.0000);
  jip->addcontrolpoint(0.7460,0.2540,1.0000);
  jip->addcontrolpoint(0.7619,0.2381,1.0000);
  jip->addcontrolpoint(0.7778,0.2222,1.0000);
  jip->addcontrolpoint(0.7937,0.2063,1.0000);
  jip->addcontrolpoint(0.8095,0.1905,1.0000);
  jip->addcontrolpoint(0.8254,0.1746,1.0000);
  jip->addcontrolpoint(0.8413,0.1587,1.0000);
  jip->addcontrolpoint(0.8571,0.1429,1.0000);
  jip->addcontrolpoint(0.8730,0.1270,1.0000);
  jip->addcontrolpoint(0.8889,0.1111,1.0000);
  jip->addcontrolpoint(0.9048,0.0952,1.0000);
  jip->addcontrolpoint(0.9206,0.0794,1.0000);
  jip->addcontrolpoint(0.9365,0.0635,1.0000);
  jip->addcontrolpoint(0.9524,0.0476,1.0000);
  jip->addcontrolpoint(0.9683,0.0317,1.0000);
  jip->addcontrolpoint(0.9841,0.0159,1.0000);
  jip->addcontrolpoint(1.0000, 0,1.0000);
  return jip;
}



JRinterpolater* GrobGlHelper::rgbramp_jet(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(0, 0,0.5625);
  jip->addcontrolpoint(0, 0,0.6250);
  jip->addcontrolpoint(0, 0,0.6875);
  jip->addcontrolpoint(0, 0,0.7500);
  jip->addcontrolpoint(0, 0,0.8125);
  jip->addcontrolpoint(0, 0,0.8750);
  jip->addcontrolpoint(0, 0,0.9375);
  jip->addcontrolpoint(0, 0,1.0000);
  jip->addcontrolpoint(0,0.0625,1.0000);
  jip->addcontrolpoint(0,0.1250,1.0000);
  jip->addcontrolpoint(0,0.1875,1.0000);
  jip->addcontrolpoint(0,0.2500,1.0000);
  jip->addcontrolpoint(0,0.3125,1.0000);
  jip->addcontrolpoint(0,0.3750,1.0000);
  jip->addcontrolpoint(0,0.4375,1.0000);
  jip->addcontrolpoint(0,0.5000,1.0000);
  jip->addcontrolpoint(0,0.5625,1.0000);
  jip->addcontrolpoint(0,0.6250,1.0000);
  jip->addcontrolpoint(0,0.6875,1.0000);
  jip->addcontrolpoint(0,0.7500,1.0000);
  jip->addcontrolpoint(0,0.8125,1.0000);
  jip->addcontrolpoint(0,0.8750,1.0000);
  jip->addcontrolpoint(0,0.9375,1.0000);
  jip->addcontrolpoint(0,1.0000,1.0000);
  jip->addcontrolpoint(0.0625,1.0000,1.0000);
  jip->addcontrolpoint(0.1250,1.0000,0.9375);
  jip->addcontrolpoint(0.1875,1.0000,0.8750);
  jip->addcontrolpoint(0.2500,1.0000,0.8125);
  jip->addcontrolpoint(0.3125,1.0000,0.7500);
  jip->addcontrolpoint(0.3750,1.0000,0.6875);
  jip->addcontrolpoint(0.4375,1.0000,0.6250);
  jip->addcontrolpoint(0.5000,1.0000,0.5625);
  jip->addcontrolpoint(0.5625,1.0000,0.5000);
  jip->addcontrolpoint(0.6250,1.0000,0.4375);
  jip->addcontrolpoint(0.6875,1.0000,0.3750);
  jip->addcontrolpoint(0.7500,1.0000,0.3125);
  jip->addcontrolpoint(0.8125,1.0000,0.2500);
  jip->addcontrolpoint(0.8750,1.0000,0.1875);
  jip->addcontrolpoint(0.9375,1.0000,0.1250);
  jip->addcontrolpoint(1.0000,1.0000,0.0625);
  jip->addcontrolpoint(1.0000,1.0000, 0);
  jip->addcontrolpoint(1.0000,0.9375, 0);
  jip->addcontrolpoint(1.0000,0.8750, 0);
  jip->addcontrolpoint(1.0000,0.8125, 0);
  jip->addcontrolpoint(1.0000,0.7500, 0);
  jip->addcontrolpoint(1.0000,0.6875, 0);
  jip->addcontrolpoint(1.0000,0.6250, 0);
  jip->addcontrolpoint(1.0000,0.5625, 0);
  jip->addcontrolpoint(1.0000,0.5000, 0);
  jip->addcontrolpoint(1.0000,0.4375, 0);
  jip->addcontrolpoint(1.0000,0.3750, 0);
  jip->addcontrolpoint(1.0000,0.3125, 0);
  jip->addcontrolpoint(1.0000,0.2500, 0);
  jip->addcontrolpoint(1.0000,0.1875, 0);
  jip->addcontrolpoint(1.0000,0.1250, 0);
  jip->addcontrolpoint(1.0000,0.0625, 0);
  jip->addcontrolpoint(1.0000, 0, 0);
  jip->addcontrolpoint(0.9375, 0, 0);
  jip->addcontrolpoint(0.8750, 0, 0);
  jip->addcontrolpoint(0.8125, 0, 0);
  jip->addcontrolpoint(0.7500, 0, 0);
  jip->addcontrolpoint(0.6875, 0, 0);
  jip->addcontrolpoint(0.6250, 0, 0);
  jip->addcontrolpoint(0.5625, 0, 0);

  return jip;
}


JRinterpolater* GrobGlHelper::rgbramp_pink(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(0.1179,0,0);
  jip->addcontrolpoint(0.1959,0.1029,0.1029);
  jip->addcontrolpoint(0.2507,0.1455,0.1455);
  jip->addcontrolpoint(0.2955,0.1782,0.1782);
  jip->addcontrolpoint(0.3343,0.2057,0.2057);
  jip->addcontrolpoint(0.3691,0.2300,0.2300);
  jip->addcontrolpoint(0.4009,0.2520,0.2520);
  jip->addcontrolpoint(0.4303,0.2722,0.2722);
  jip->addcontrolpoint(0.4579,0.2910,0.2910);
  jip->addcontrolpoint(0.4839,0.3086,0.3086);
  jip->addcontrolpoint(0.5085,0.3253,0.3253);
  jip->addcontrolpoint(0.5320,0.3412,0.3412);
  jip->addcontrolpoint(0.5546,0.3563,0.3563);
  jip->addcontrolpoint(0.5762,0.3709,0.3709);
  jip->addcontrolpoint(0.5971,0.3849,0.3849);
  jip->addcontrolpoint(0.6172,0.3984,0.3984);
  jip->addcontrolpoint(0.6367,0.4115,0.4115);
  jip->addcontrolpoint(0.6557,0.4241,0.4241);
  jip->addcontrolpoint(0.6741,0.4364,0.4364);
  jip->addcontrolpoint(0.6920,0.4484,0.4484);
  jip->addcontrolpoint(0.7094,0.4600,0.4600);
  jip->addcontrolpoint(0.7265,0.4714,0.4714);
  jip->addcontrolpoint(0.7431,0.4825,0.4825);
  jip->addcontrolpoint(0.7594,0.4933,0.4933);
  jip->addcontrolpoint(0.7664,0.5175,0.5040);
  jip->addcontrolpoint(0.7732,0.5407,0.5143);
  jip->addcontrolpoint(0.7800,0.5628,0.5245);
  jip->addcontrolpoint(0.7868,0.5842,0.5345);
  jip->addcontrolpoint(0.7935,0.6048,0.5443);
  jip->addcontrolpoint(0.8001,0.6247,0.5540);
  jip->addcontrolpoint(0.8067,0.6440,0.5634);
  jip->addcontrolpoint(0.8133,0.6627,0.5727);
  jip->addcontrolpoint(0.8197,0.6809,0.5819);
  jip->addcontrolpoint(0.8262,0.6986,0.5909);
  jip->addcontrolpoint(0.8325,0.7159,0.5998);
  jip->addcontrolpoint(0.8389,0.7328,0.6086);
  jip->addcontrolpoint(0.8452,0.7493,0.6172);
  jip->addcontrolpoint(0.8514,0.7655,0.6257);
  jip->addcontrolpoint(0.8576,0.7813,0.6341);
  jip->addcontrolpoint(0.8637,0.7968,0.6424);
  jip->addcontrolpoint(0.8698,0.8120,0.6506);
  jip->addcontrolpoint(0.8759,0.8270,0.6587);
  jip->addcontrolpoint(0.8819,0.8416,0.6667);
  jip->addcontrolpoint(0.8879,0.8560,0.6746);
  jip->addcontrolpoint(0.8938,0.8702,0.6824);
  jip->addcontrolpoint(0.8997,0.8842,0.6901);
  jip->addcontrolpoint(0.9056,0.8979,0.6977);
  jip->addcontrolpoint(0.9114,0.9114,0.7052);
  jip->addcontrolpoint(0.9172,0.9172,0.7272);
  jip->addcontrolpoint(0.9230,0.9230,0.7485);
  jip->addcontrolpoint(0.9287,0.9287,0.7692);
  jip->addcontrolpoint(0.9344,0.9344,0.7893);
  jip->addcontrolpoint(0.9400,0.9400,0.8090);
  jip->addcontrolpoint(0.9456,0.9456,0.8282);
  jip->addcontrolpoint(0.9512,0.9512,0.8469);
  jip->addcontrolpoint(0.9567,0.9567,0.8653);
  jip->addcontrolpoint(0.9623,0.9623,0.8832);
  jip->addcontrolpoint(0.9677,0.9677,0.9008);
  jip->addcontrolpoint(0.9732,0.9732,0.9181);
  jip->addcontrolpoint(0.9786,0.9786,0.9351);
  jip->addcontrolpoint(0.9840,0.9840,0.9517);
  jip->addcontrolpoint(0.9894,0.9894,0.9681);
  jip->addcontrolpoint(0.9947,0.9947,0.9842);
  jip->addcontrolpoint(1.0000,1.0000,1.0000);

  return jip;
}


JRinterpolater* GrobGlHelper::rgbramp_bone(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(0,0,0.0052);
  jip->addcontrolpoint(0.0139,0.0139,0.0243);
  jip->addcontrolpoint(0.0278,0.0278,0.0434);
  jip->addcontrolpoint(0.0417,0.0417,0.0625);
  jip->addcontrolpoint(0.0556,0.0556,0.0816);
  jip->addcontrolpoint(0.0694,0.0694,0.1007);
  jip->addcontrolpoint(0.0833,0.0833,0.1198);
  jip->addcontrolpoint(0.0972,0.0972,0.1389);
  jip->addcontrolpoint(0.1111,0.1111,0.1580);
  jip->addcontrolpoint(0.1250,0.1250,0.1771);
  jip->addcontrolpoint(0.1389,0.1389,0.1962);
  jip->addcontrolpoint(0.1528,0.1528,0.2153);
  jip->addcontrolpoint(0.1667,0.1667,0.2344);
  jip->addcontrolpoint(0.1806,0.1806,0.2535);
  jip->addcontrolpoint(0.1944,0.1944,0.2726);
  jip->addcontrolpoint(0.2083,0.2083,0.2917);
  jip->addcontrolpoint(0.2222,0.2222,0.3108);
  jip->addcontrolpoint(0.2361,0.2361,0.3299);
  jip->addcontrolpoint(0.2500,0.2500,0.3490);
  jip->addcontrolpoint(0.2639,0.2639,0.3681);
  jip->addcontrolpoint(0.2778,0.2778,0.3872);
  jip->addcontrolpoint(0.2917,0.2917,0.4062);
  jip->addcontrolpoint(0.3056,0.3056,0.4253);
  jip->addcontrolpoint(0.3194,0.3194,0.4444);
  jip->addcontrolpoint(0.3333,0.3385,0.4583);
  jip->addcontrolpoint(0.3472,0.3576,0.4722);
  jip->addcontrolpoint(0.3611,0.3767,0.4861);
  jip->addcontrolpoint(0.3750,0.3958,0.5000);
  jip->addcontrolpoint(0.3889,0.4149,0.5139);
  jip->addcontrolpoint(0.4028,0.4340,0.5278);
  jip->addcontrolpoint(0.4167,0.4531,0.5417);
  jip->addcontrolpoint(0.4306,0.4722,0.5556);
  jip->addcontrolpoint(0.4444,0.4913,0.5694);
  jip->addcontrolpoint(0.4583,0.5104,0.5833);
  jip->addcontrolpoint(0.4722,0.5295,0.5972);
  jip->addcontrolpoint(0.4861,0.5486,0.6111);
  jip->addcontrolpoint(0.5000,0.5677,0.6250);
  jip->addcontrolpoint(0.5139,0.5868,0.6389);
  jip->addcontrolpoint(0.5278,0.6059,0.6528);
  jip->addcontrolpoint(0.5417,0.6250,0.6667);
  jip->addcontrolpoint(0.5556,0.6441,0.6806);
  jip->addcontrolpoint(0.5694,0.6632,0.6944);
  jip->addcontrolpoint(0.5833,0.6823,0.7083);
  jip->addcontrolpoint(0.5972,0.7014,0.7222);
  jip->addcontrolpoint(0.6111,0.7205,0.7361);
  jip->addcontrolpoint(0.6250,0.7396,0.7500);
  jip->addcontrolpoint(0.6389,0.7587,0.7639);
  jip->addcontrolpoint(0.6528,0.7778,0.7778);
  jip->addcontrolpoint(0.6745,0.7917,0.7917);
  jip->addcontrolpoint(0.6962,0.8056,0.8056);
  jip->addcontrolpoint(0.7179,0.8194,0.8194);
  jip->addcontrolpoint(0.7396,0.8333,0.8333);
  jip->addcontrolpoint(0.7613,0.8472,0.8472);
  jip->addcontrolpoint(0.7830,0.8611,0.8611);
  jip->addcontrolpoint(0.8047,0.8750,0.8750);
  jip->addcontrolpoint(0.8264,0.8889,0.8889);
  jip->addcontrolpoint(0.8481,0.9028,0.9028);
  jip->addcontrolpoint(0.8698,0.9167,0.9167);
  jip->addcontrolpoint(0.8915,0.9306,0.9306);
  jip->addcontrolpoint(0.9132,0.9444,0.9444);
  jip->addcontrolpoint(0.9349,0.9583,0.9583);
  jip->addcontrolpoint(0.9566,0.9722,0.9722);
  jip->addcontrolpoint(0.9783,0.9861,0.9861);
  jip->addcontrolpoint(1.0000,1.0000,1.0000);

  return jip;
}

JRinterpolater* GrobGlHelper::rgbramp_copper(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(0,0,0);
  jip->addcontrolpoint(0.0198,0.0124,0.0079);
  jip->addcontrolpoint(0.0397,0.0248,0.0158);
  jip->addcontrolpoint(0.0595,0.0372,0.0237);
  jip->addcontrolpoint(0.0794,0.0496,0.0316);
  jip->addcontrolpoint(0.0992,0.0620,0.0395);
  jip->addcontrolpoint(0.1190,0.0744,0.0474);
  jip->addcontrolpoint(0.1389,0.0868,0.0553);
  jip->addcontrolpoint(0.1587,0.0992,0.0632);
  jip->addcontrolpoint(0.1786,0.1116,0.0711);
  jip->addcontrolpoint(0.1984,0.1240,0.0790);
  jip->addcontrolpoint(0.2183,0.1364,0.0869);
  jip->addcontrolpoint(0.2381,0.1488,0.0948);
  jip->addcontrolpoint(0.2579,0.1612,0.1027);
  jip->addcontrolpoint(0.2778,0.1736,0.1106);
  jip->addcontrolpoint(0.2976,0.1860,0.1185);
  jip->addcontrolpoint(0.3175,0.1984,0.1263);
  jip->addcontrolpoint(0.3373,0.2108,0.1342);
  jip->addcontrolpoint(0.3571,0.2232,0.1421);
  jip->addcontrolpoint(0.3770,0.2356,0.1500);
  jip->addcontrolpoint(0.3968,0.2480,0.1579);
  jip->addcontrolpoint(0.4167,0.2604,0.1658);
  jip->addcontrolpoint(0.4365,0.2728,0.1737);
  jip->addcontrolpoint(0.4563,0.2852,0.1816);
  jip->addcontrolpoint(0.4762,0.2976,0.1895);
  jip->addcontrolpoint(0.4960,0.3100,0.1974);
  jip->addcontrolpoint(0.5159,0.3224,0.2053);
  jip->addcontrolpoint(0.5357,0.3348,0.2132);
  jip->addcontrolpoint(0.5556,0.3472,0.2211);
  jip->addcontrolpoint(0.5754,0.3596,0.2290);
  jip->addcontrolpoint(0.5952,0.3720,0.2369);
  jip->addcontrolpoint(0.6151,0.3844,0.2448);
  jip->addcontrolpoint(0.6349,0.3968,0.2527);
  jip->addcontrolpoint(0.6548,0.4092,0.2606);
  jip->addcontrolpoint(0.6746,0.4216,0.2685);
  jip->addcontrolpoint(0.6944,0.4340,0.2764);
  jip->addcontrolpoint(0.7143,0.4464,0.2843);
  jip->addcontrolpoint(0.7341,0.4588,0.2922);
  jip->addcontrolpoint(0.7540,0.4712,0.3001);
  jip->addcontrolpoint(0.7738,0.4836,0.3080);
  jip->addcontrolpoint(0.7937,0.4960,0.3159);
  jip->addcontrolpoint(0.8135,0.5084,0.3238);
  jip->addcontrolpoint(0.8333,0.5208,0.3317);
  jip->addcontrolpoint(0.8532,0.5332,0.3396);
  jip->addcontrolpoint(0.8730,0.5456,0.3475);
  jip->addcontrolpoint(0.8929,0.5580,0.3554);
  jip->addcontrolpoint(0.9127,0.5704,0.3633);
  jip->addcontrolpoint(0.9325,0.5828,0.3712);
  jip->addcontrolpoint(0.9524,0.5952,0.3790);
  jip->addcontrolpoint(0.9722,0.6076,0.3869);
  jip->addcontrolpoint(0.9921,0.6200,0.3948);
  jip->addcontrolpoint(1.0000,0.6324,0.4027);
  jip->addcontrolpoint(1.0000,0.6448,0.4106);
  jip->addcontrolpoint(1.0000,0.6572,0.4185);
  jip->addcontrolpoint(1.0000,0.6696,0.4264);
  jip->addcontrolpoint(1.0000,0.6820,0.4343);
  jip->addcontrolpoint(1.0000,0.6944,0.4422);
  jip->addcontrolpoint(1.0000,0.7068,0.4501);
  jip->addcontrolpoint(1.0000,0.7192,0.4580);
  jip->addcontrolpoint(1.0000,0.7316,0.4659);
  jip->addcontrolpoint(1.0000,0.7440,0.4738);
  jip->addcontrolpoint(1.0000,0.7564,0.4817);
  jip->addcontrolpoint(1.0000,0.7688,0.4896);
  jip->addcontrolpoint(1.0000,0.7812,0.4975);

  return jip;
}

JRinterpolater* GrobGlHelper::rgbramp_gray(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(0,0,0);
  jip->addcontrolpoint(0.0159,0.0159,0.0159);
  jip->addcontrolpoint(0.0317,0.0317,0.0317);
  jip->addcontrolpoint(0.0476,0.0476,0.0476);
  jip->addcontrolpoint(0.0635,0.0635,0.0635);
  jip->addcontrolpoint(0.0794,0.0794,0.0794);
  jip->addcontrolpoint(0.0952,0.0952,0.0952);
  jip->addcontrolpoint(0.1111,0.1111,0.1111);
  jip->addcontrolpoint(0.1270,0.1270,0.1270);
  jip->addcontrolpoint(0.1429,0.1429,0.1429);
  jip->addcontrolpoint(0.1587,0.1587,0.1587);
  jip->addcontrolpoint(0.1746,0.1746,0.1746);
  jip->addcontrolpoint(0.1905,0.1905,0.1905);
  jip->addcontrolpoint(0.2063,0.2063,0.2063);
  jip->addcontrolpoint(0.2222,0.2222,0.2222);
  jip->addcontrolpoint(0.2381,0.2381,0.2381);
  jip->addcontrolpoint(0.2540,0.2540,0.2540);
  jip->addcontrolpoint(0.2698,0.2698,0.2698);
  jip->addcontrolpoint(0.2857,0.2857,0.2857);
  jip->addcontrolpoint(0.3016,0.3016,0.3016);
  jip->addcontrolpoint(0.3175,0.3175,0.3175);
  jip->addcontrolpoint(0.3333,0.3333,0.3333);
  jip->addcontrolpoint(0.3492,0.3492,0.3492);
  jip->addcontrolpoint(0.3651,0.3651,0.3651);
  jip->addcontrolpoint(0.3810,0.3810,0.3810);
  jip->addcontrolpoint(0.3968,0.3968,0.3968);
  jip->addcontrolpoint(0.4127,0.4127,0.4127);
  jip->addcontrolpoint(0.4286,0.4286,0.4286);
  jip->addcontrolpoint(0.4444,0.4444,0.4444);
  jip->addcontrolpoint(0.4603,0.4603,0.4603);
  jip->addcontrolpoint(0.4762,0.4762,0.4762);
  jip->addcontrolpoint(0.4921,0.4921,0.4921);
  jip->addcontrolpoint(0.5079,0.5079,0.5079);
  jip->addcontrolpoint(0.5238,0.5238,0.5238);
  jip->addcontrolpoint(0.5397,0.5397,0.5397);
  jip->addcontrolpoint(0.5556,0.5556,0.5556);
  jip->addcontrolpoint(0.5714,0.5714,0.5714);
  jip->addcontrolpoint(0.5873,0.5873,0.5873);
  jip->addcontrolpoint(0.6032,0.6032,0.6032);
  jip->addcontrolpoint(0.6190,0.6190,0.6190);
  jip->addcontrolpoint(0.6349,0.6349,0.6349);
  jip->addcontrolpoint(0.6508,0.6508,0.6508);
  jip->addcontrolpoint(0.6667,0.6667,0.6667);
  jip->addcontrolpoint(0.6825,0.6825,0.6825);
  jip->addcontrolpoint(0.6984,0.6984,0.6984);
  jip->addcontrolpoint(0.7143,0.7143,0.7143);
  jip->addcontrolpoint(0.7302,0.7302,0.7302);
  jip->addcontrolpoint(0.7460,0.7460,0.7460);
  jip->addcontrolpoint(0.7619,0.7619,0.7619);
  jip->addcontrolpoint(0.7778,0.7778,0.7778);
  jip->addcontrolpoint(0.7937,0.7937,0.7937);
  jip->addcontrolpoint(0.8095,0.8095,0.8095);
  jip->addcontrolpoint(0.8254,0.8254,0.8254);
  jip->addcontrolpoint(0.8413,0.8413,0.8413);
  jip->addcontrolpoint(0.8571,0.8571,0.8571);
  jip->addcontrolpoint(0.8730,0.8730,0.8730);
  jip->addcontrolpoint(0.8889,0.8889,0.8889);
  jip->addcontrolpoint(0.9048,0.9048,0.9048);
  jip->addcontrolpoint(0.9206,0.9206,0.9206);
  jip->addcontrolpoint(0.9365,0.9365,0.9365);
  jip->addcontrolpoint(0.9524,0.9524,0.9524);
  jip->addcontrolpoint(0.9683,0.9683,0.9683);
  jip->addcontrolpoint(0.9841,0.9841,0.9841);
  jip->addcontrolpoint(1.0000,1.0000,1.0000);

  return jip;
}

JRinterpolater* GrobGlHelper::rgbramp_hsv(int levels)
{
  // build an interpolator that can do a rgb color ramp
  JRinterpolater *jip=new JRinterpolater(0,1,3);

  jip->addcontrolpoint(1.0000,0,0);
  jip->addcontrolpoint(1.0000,0.0938,0);
  jip->addcontrolpoint(1.0000,0.1875,0);
  jip->addcontrolpoint(1.0000,0.2813,0);
  jip->addcontrolpoint(1.0000,0.3750,0);
  jip->addcontrolpoint(1.0000,0.4688,0);
  jip->addcontrolpoint(1.0000,0.5625,0);
  jip->addcontrolpoint(1.0000,0.6563,0);
  jip->addcontrolpoint(1.0000,0.7500,0);
  jip->addcontrolpoint(1.0000,0.8438,0);
  jip->addcontrolpoint(1.0000,0.9375,0);
  jip->addcontrolpoint(0.9688,1.0000,0);
  jip->addcontrolpoint(0.8750,1.0000,0);
  jip->addcontrolpoint(0.7813,1.0000,0);
  jip->addcontrolpoint(0.6875,1.0000,0);
  jip->addcontrolpoint(0.5938,1.0000,0);
  jip->addcontrolpoint(0.5000,1.0000,0);
  jip->addcontrolpoint(0.4063,1.0000,0);
  jip->addcontrolpoint(0.3125,1.0000,0);
  jip->addcontrolpoint(0.2188,1.0000,0);
  jip->addcontrolpoint(0.1250,1.0000,0);
  jip->addcontrolpoint(0.0313,1.0000,0);
  jip->addcontrolpoint( 0,1.0000,0.0625);
  jip->addcontrolpoint( 0,1.0000,0.1563);
  jip->addcontrolpoint( 0,1.0000,0.2500);
  jip->addcontrolpoint( 0,1.0000,0.3438);
  jip->addcontrolpoint( 0,1.0000,0.4375);
  jip->addcontrolpoint( 0,1.0000,0.5313);
  jip->addcontrolpoint( 0,1.0000,0.6250);
  jip->addcontrolpoint( 0,1.0000,0.7188);
  jip->addcontrolpoint( 0,1.0000,0.8125);
  jip->addcontrolpoint( 0,1.0000,0.9063);
  jip->addcontrolpoint( 0,1.0000,1.0000);
  jip->addcontrolpoint( 0,0.9063,1.0000);
  jip->addcontrolpoint( 0,0.8125,1.0000);
  jip->addcontrolpoint( 0,0.7188,1.0000);
  jip->addcontrolpoint( 0,0.6250,1.0000);
  jip->addcontrolpoint( 0,0.5313,1.0000);
  jip->addcontrolpoint( 0,0.4375,1.0000);
  jip->addcontrolpoint( 0,0.3438,1.0000);
  jip->addcontrolpoint( 0,0.2500,1.0000);
  jip->addcontrolpoint( 0,0.1563,1.0000);
  jip->addcontrolpoint( 0,0.0625,1.0000);
  jip->addcontrolpoint(0.0313,0,1.0000);
  jip->addcontrolpoint(0.1250,0,1.0000);
  jip->addcontrolpoint(0.2188,0,1.0000);
  jip->addcontrolpoint(0.3125,0,1.0000);
  jip->addcontrolpoint(0.4063,0,1.0000);
  jip->addcontrolpoint(0.5000,0,1.0000);
  jip->addcontrolpoint(0.5938,0,1.0000);
  jip->addcontrolpoint(0.6875,0,1.0000);
  jip->addcontrolpoint(0.7813,0,1.0000);
  jip->addcontrolpoint(0.8750,0,1.0000);
  jip->addcontrolpoint(0.9688,0,1.0000);
  jip->addcontrolpoint(1.0000,0,0.9375);
  jip->addcontrolpoint(1.0000,0,0.8438);
  jip->addcontrolpoint(1.0000,0,0.7500);
  jip->addcontrolpoint(1.0000,0,0.6563);
  jip->addcontrolpoint(1.0000,0,0.5625);
  jip->addcontrolpoint(1.0000,0,0.4688);
  jip->addcontrolpoint(1.0000,0,0.3750);
  jip->addcontrolpoint(1.0000,0,0.2813);
  jip->addcontrolpoint(1.0000,0,0.1875);
  jip->addcontrolpoint(1.0000,0,0.0938);

  return jip;
}

