// JRinterpolate.h
// trivial class for performing simple linear interpolates (ie rgb color ramps)

// forward declarations
class JRinterpolater;

// start file
#ifndef INC_JRinterpolater
#define INC_JRinterpolater

#include <iostream>




//--------------------------------------------------------------------------------
//---- JRinterpolater
//--------------------------------------------------------------------------------
//: A class for interoplating between values (like RGB gradients)

class JRinterpolater
{
private:
  float min,max,dif;
  int maxpoints;
  int controlpoints;
  int order;
  float *datap;
public:
  JRinterpolater(float inmin,float inmax,int inorder);
  ~JRinterpolater();
public:
  void addcontrolpoint(float *values);
  void addcontrolpoint(float val1);
  void addcontrolpoint(float val1,float val2);
  void addcontrolpoint(float val1,float val2,float val3);
public:
  void interpolate(float lookpos,float *ivalues);
  float position(int pointnum) {return min+(dif/(controlpoints-1))*pointnum;};
  float *location(int pointnum) {return &datap[pointnum*order];};
private:
  float *newpoint();
  void allocate(int numpoints);
  void deallocate();
};
















// }
// Namespace close-brace
#endif
